# installation menu for xtem_TeXMenu
#
# Copyright (C) 1994  G. Lamprecht, W. Lotz, R. Weibezahn; LRW c/o Bremen University
# Copyright (C) 1996  G. Lamprecht, W. Lotz, R. Weibezahn; IWD, Bremen University
#
##############################################################################################

set copyright "Copyright 1996  G.Lamprecht, W.Lotz, R.Weibezahn; LRW/IWD, Bremen University"
set email     "e-mail: weibezahn@iwd.uni-bremen.de"
set www       "WWW:    http://ftp.iwd.uni-bremen.de/xtem/xtem_texmenu.html"
set testPut 0; # 0: no testoutput at all; 1: testoutput according to bell_level 0 (much output) | 1 | ... | 4 (no putput)
set bell_level 0
set RequestActive 0

set INSTPATH        "[lindex $argv  0]"
set BINPATH         "[lindex $argv  1]"
set MANPATH         "[lindex $argv  2]"
set WISHCALL        "[lindex $argv  3]"
set XTERMCALL       "[lindex $argv  4]"
set XTEMVERSION     "[lindex $argv  5]"
set LANGUAGES       "[lindex $argv  6]"
set DEFAULTLANGUAGE "[lindex $argv  7]"
set XiMaxBoxWidth   "[lindex $argv  8]"

set stt ""
source ut.tcl; source xV.tcl; set XiInstallationRuns 1

# now set array vv with texts for this xtem release
set f [open "help_$DEFAULTLANGUAGE/button.texts" r]
while {[gets $f z]>=0} {set z "[string trim $z] "; set p [string first " " $z]
                        set vv([crange $z 0 $p-1]) [string trim [crange $z $p end]]
}
close $f

if {"$INSTPATH"=="$BINPATH"} {puts stdout "\n***** Error: BINPATH cannot be set to $INSTPATH\n"; mybell 4; exit}

proc XiProtokoll {text} {puts stdout "$text"; flush stdout; if [winfo exists .d.tt] {writescr .d.tt "$text\n"}}
proc XiProtokollEnd1 {text} {global XiProtEndText1; XiProtokoll "$text"; set  XiProtEndText1 "${XiProtEndText1}$text\n"}
proc XiProtokollEnd2 {text} {global XiProtEndText2; XiProtokoll "$text"; set  XiProtEndText2 "${XiProtEndText2}$text\n"}

set NEWV "$XTEMVERSION"; set NEW "xtem-$NEWV"

set Wvsts  ".xteminstall_vsts";  # main menu
set Wenews ".xteminstall_enews"; # edit local news files
set Wevst  ".xteminstall_evst";  # edit vst file: all buttons
set Wevstb ".xteminstall_evstb"; # edit vst file (all the file in one text widget)
set Wevstl ".xteminstall_evstl"; # edit vst file (one entry, splitted into parameters) 
set Wevsta ".xteminstall_evsta"; # append a parameter to a vst file (if variable # of parameters)
set Wevstd ".xteminstall_evstd"; # delete a parameter from a vst file (if variable # of parameters)

set XiVstPBDLw ""

set XV(AAsteriks) "********************************************************************************"
set XV(anever)    "String which never should occur normally!"
set XV(anoact)    "the selected entry is not an active one ---"
set XV(anoact)     "$XV(anoact) select an active entry or `make_active' or `copy_to_active' first!"
set XV(anocopy)   "the selected entry cannot be copied!"
set XV(anodelete) "this entry cannot be deleted!"
set XV(anoentry)  "no entry selected --- select entry first!"
set XV(anoinact)  "the selected entry is not a comment --- select an entry from the comment list!"
set XV(anomove)   "the selected entry cannot be moved!"
set XV(anomovedo) "the selected entry cannot be moved downwards within this list any more!"
set XV(anomoveup) "the selected entry cannot be moved upwards within this list any more!"
set XV(MkCmdNCol1) "New column generated for Tcl version"
set XV(MkCmdNCol2) "complete all lines (starting with the 2nd line) according to your system!"
set XV(Xeebabrt)  "abort"
set XV(Xeebends)  "end"
set XV(Xeebnext)  "down"
set XV(Xeebprev)  "up"
set XV(Xeebpdel)  "delete_parameter"
set XV(Xeebpadd)  "add_parameter"
set XV(Xeetabrt)  "abort this window"
set XV(Xeetends)  "ends this window (saving changes done in this window!)"
set XV(Xeetnext)  "switch to the next entry in the entry list (saving changes done in this window!)"
set XV(Xeetprev)  "switch to the previous entry  in the entry list (saving changes done in this window!)"
set XV(Xeetpdel)  "after clicking this button you can specify the parameter to be deleted (from each entry)"
set XV(Xeetpadd)  "after clicking this button you can specify a new parameter to be added (to each entry)"
set XV(XSettVButtons) "1 2 3 4 5 6 7 8 9 10 11 12"
set XV(XSettVBut1)  "edit_all_entries XiSettVBEditBuff  {edit all entries in a text edit widget} {}"
set XV(XSettVBut2)  "append_new_entry XiSettVBAppdNewE  {create a new active entry and edit this entry} {}"
set XV(XSettVBut3)  "copy_to_active   XiSettVBCopyAct   {copy the selected inactive entry to the active entries} \
							{selected entry is copied}"
set XV(XSettVBut4)  "copy_to_inactive XiSettVBCopyInact {copy the selected active entry to the comment lines} \
							{selected entry is copied}"
set XV(XSettVBut5)  "edit_one_entry   XiSettVBEditEntry {edit the selected active entry} {}"
set XV(XSettVBut6)  "delete_entry     XiSettVBDeltEntry {delete selected entry} {selected entry is deleted}"
set XV(XSettVBut7)  "make_active      XiSettVBMakeActiv {move the selected comment line to the active entries} \
							{selected entry is moved to active entries}"
set XV(XSettVBut8)  "make_inactive    XiSettVBMakeInact {move the selected active entry to the comment lines} \
							{selected entry is moved to comments}"
set XV(XSettVBut9)  "copy&edit_entry  XiSettVBCpEdEntry {copy the selected active entry and edit the copy} {}"
set XV(XSettVBut10) "move_to_default  XiSettVBMoveDeflt {move the selected entry to default position} \
							{moved to default position}"
set XV(XSettVBut11) "move_1_up        XiSettVBMove1Up   {move the selected entry 1 line up} \
							{selected entry moved up}"
set XV(XSettVBut12) "move_1_down      XiSettVBMove1Down {move the selected entry 1 line down} \
							{selected entry moved down}"
set XV(XSettVBut13) "$XV(Xeebpdel)    XiSettVBParDel    {$XV(Xeetpdel)} {}"
set XV(XSettVBut14) "$XV(Xeebpadd)    XiSettVBParAdd    {$XV(Xeetpadd)} {}"
set XV(XSettVComgerman)  "*** ab hier \"Kommentar\" (Leerzeile beendet den ausgewerteten Teil der Datei!)"
set XV(XSettVComenglish) "*** the preceding empty line ends the setting file, the following is \"comment\""
set XiVstLO 10; # Vst-List-Offset for the following specifications in XV(XSettVF...)
# [lindex (XV(XSettVF...)  0] : file has separator (1) or not (0)
# [lindex (XV(XSettVF...)  1] : criteria line (1) or no criteria line (0)
# [lindex (XV(XSettVF...)  2] : number of parameters (without user added parameters, see printing.vst)
# [lindex (XV(XSettVF...)  3] : user may specify new parameters. eg. printing.vst (1) or not (0)
# [lindex (XV(XSettVF...)  4] : width for entry/text widgets in vst-entry-change window
# [lindex (XV(XSettVF...)  5] : width for labels in vst-entry-change window
# [lindex (XV(XSettVF...)  6] : position for label relative to entry/text widgets in vst-entry-change window
# [lindex (XV(XSettVF...)  7] : current number of parameters (will be set by xi.tcl, procedure XiSettEditVst)
# [lindex (XV(XSettVF...)  8] : 
# [lindex (XV(XSettVF...)  9] : 
# [lindex (XV(XSettVF...) 10] : list:  p0 | {p0 [p1 [p2 p3]]}
#                                   p0: parameter_name (_ if unused, e.g. printing.vst)
#                                   p1: =1 if_parameter_must_be_nonempty; blank or 0 otherwise
#                                   p2: blank if no "suboptions", otherwise 
#                                       number of lines for text edit widget for this parameter (see printing.vst)
set XV(XSettVFbibtex.vst)      "1 0  1 0 45 30 top  {} {} {} {bitext 1} {bibtex 1} bioptions"
set XV(XSettVFcleanup.vst)     "1 0  1 0 10 30 top  {} {} {} {aufsuff 1} {auftoggle 1}"
set XV(XSettVFeditor.vst)      "1 0  3 0 50 30 top  {} {} {} {edtext 1} edxterm {editor 1} edoptions"
set XV(XSettVFindex.vst)       "1 0  2 0 55 30 top  {} {} {} {intext 1} {index 1} inoptions"
set XV(XSettVFinstall.vst)     "0 0  1 0 60 30 top  {} {} {} variable_name variable_value"
set XV(XSettVFletters.vst)     "1 0  0 0 50 30 top  {} {} {} "
set XV(XSettVFloganalyze.vst)  "1 0  2 0 24 30 top  {} {} {} {texlogatext 1} {texloganalyze 1} texlogopts"
set XV(XSettVFlogform.vst)     "1 0  3 0 45 30 top  {} {} {} {logtext 1} logterm {logform 1} logoptions"
set XV(XSettVFlogsuffix.vst)   "0 0  1 0 45 30 top  {} {} {} lsuff_&_text_describing_the_logfile"
set XV(XSettVFmkcommand.vst)   "1 0  0 1 60 30 top  {} {} {} {text 1}"
set XV(XSettVFpreview.vst)     "1 0  4 0 52 30 top  {} {} {} {prtext 1} {preview 1} {prsuffix 1} proptions {prvformat 1}"
set XV(XSettVFprinting.vst)    "1 1 11 1 60 15 left {} {} {} {text 1} {printer 1} {emulation 1} {prtdriver 1} {prtsuf 1}"
set XV(XSettVFprinting.vst) "$XV(XSettVFprinting.vst) prtoptions {lpcmd 1} lpopt _ _ _ {prformat 1 4}"
set XV(XSettVFprt_dvi2xyz.vst) "1 0  2 0 85 30 top  {} {} {} {prmtext 1} prmrelabs {prmsel 1}"
set XV(XSettVFspellcheck.vst)  "1 0  5 0 80 30 top  {} {} {} {sptext 1} {spcmd 1} splang spcorr spselect spoptions"
set XV(XSettVFsuffix.vst)      "0 0  0 0 20 30 top  {} {} {} esuff"
set XV(XSettVFsyntax.vst)      "1 0  2 0 55 30 top  {} {} {} {sytext 1} {syntax 1} syoptions"
set XV(XSettVFtexfmt.vst)      "1 0  9 0 50 30 top  {} {} {} {text 1} {texfmt 1} quickenable quickverbatim quickprereq"
set XV(XSettVFtexfmt.vst)   "$XV(XSettVFtexfmt.vst) quickpreform quicksuffix quickpreamble quickendpre quickenddoc"
set XV(XSettVFtexmax.vst)      "0 0  0 0 10 30 top  {} {} {} texmax"
set XV(XSettVFtexsiz.vst)      "1 0  1 0 12 30 top  {} {} {} {texmtext 1} texmem"
set XV(XSettVFtexsuffix.vst)   "0 0  0 0 10 30 top  {} {} {} texsuffix"
set XV(XSettVFutility.vst)     "1 0  6 0 50 30 top  {} {} {} {text 1} {command 1} options file_requested default_suffix"
set XV(XSettVFutility.vst)  "$XV(XSettVFutility.vst)  suffix_list cd_dir"


set alink1    "Symbolic links are not available at this Tcl installation; xteminstall thus "
set alink2    "cannot run. Sorry, but you have to do the installation manually, see Installation Guide!"
if {[info commands link]==""} {XiProtokoll "$alink1\n$alink2\n"; exit}; # link command available?


setTclVersions
if {$tclversion<7.4} {puts stdout "This version of xtem needs a newer Tcl version!"; exit}

#----- main menu        ----------------------------------------------------------------------

wm iconname . "xteminstall";  wm title . "xteminstall: [pwd] (version: $NEWV)";  wm minsize . 300 50
TestPut 3 "********************** Start main procedure!"


# top section buttons (end, install, settings)

frame .a; pack .a -fill x
button .a.ende -text "end" -command {destroy .}
label .a.dummy -width 5
button .a.inst -text "install xtem" -width 20 -command {XiInstall};  # "install" section
button .a.vsts -text "change settings" -width 20 -command {XiSettings}; #  modify "settings"
pack .a.ende .a.dummy .a.inst .a.vsts -side left -padx 5 -pady 5


set textxscroll 1; set xtemTyh 25; set Wx  .xtemx; InsertTextFrame "" $xtemTyh


#----- installation proc's -------------------------------------------------------------------

proc XiGetVersion {dir} {
 TestPut 3 ""

 if {[file exists $dir/xV.tcl]||[file exists $dir/xtem.tcl]} {
   if [file exists $dir/xV.tcl] {set file xV.tcl; #version>=5.01} else {set file xtem.tcl; #version<=5.00}
   set ret "old"
   set f [open $dir/$file]
   for {set i 1} {$i<=40} {incr i} {
     getscl $f z;                         set e [string trim $z];                set p [string first " " $e];set w1 "$e"
     if {$p>0} {set w1 [crange $e 0 $p-1];set e [string trim [crange $e $p end]];set p [string first " " $e];set w2 "$e"}
     if {$p>0} {set w2 [crange $e 0 $p-1];set e [string trim [crange $e $p end]];set p [string first " " $e];set w3 "$e"}
     if {$p>0} {set w3 [crange $e 0 $p-1]}
     if {($w1=="set")&&($w2=="version")&&([string index $w3 0]=={"})} {
       if {[string first ";" $e]>0} {set e [crange $e 0 [string first ";" $e]-1]}
       set ret [lindex $e 0]
     }
   }
   close $f
   return $ret
 }
  
}

proc XiChmod {mode names} {
 TestPut 2 ""
 XiProtokoll "\t chmod $mode $names"
 foreach n $names {if [file exists $n] {chmod $mode $n} else {chmod $mode "[glob -- $n]"} }
 update
}

proc XiFillString {string length} {# fills string up to lenght with trailing blanks
 TestPut 2 ""
 while {[string length $string]<$length} {set string "$string "}; return "$string"
}

proc XiNotInstalledText {} \
 {return " <--- this file couldn't be installed\n(no write permission); restart xteminstall once more,  or do manually:"}

#----- installation        -------------------------------------------------------------------

proc XiInstall {} {

 global XV NEWV NEW XTEMV XTEM OLDV OLD INSTPATH BINPATH MANPATH WISHCALL XTERMCALL 
 global LANGUAGES DEFAULTLANGUAGE env whichcheck CHANGECODE_C tclversion mkcommand
 global XiVstActive XiVstInactive XiCurLanguage XiVstHasSep xtem_path language XiProtEndText1 XiProtEndText2
 global MkcmdTclVColNr
 TestPut 3 ""

 set XiProtEndText1 ""; set XiProtEndText2 ""

 if [info exists env(PATH)] {set whichcheck "yes"} else {set whichcheck "no"}
 
 foreach b ".a.ende .a.inst .a.vsts" {$b configure -state disabled}; update

 XiProtokoll "$XV(AAsteriks)\nInstallation starts now ...\n"

 # look for $INSTPATH/xtem
 # if $INSTPATH/xtem exists, it is only allowed to be directory or link; if it's a file ---> exit!
 if [file isfile $INSTPATH/xtem] {XiProtokoll "Error - this should be a directory, but is a file: $INSTPATH/xtem"; exit}

 if [file isdirectory $INSTPATH/xtem] {
   if {[file type $INSTPATH/xtem]=="link"} {set XLINK 1} else {set XLINK 0}
   set XTEMV [XiGetVersion $INSTPATH/xtem]; set XTEM "xtem"
 } else {
   set XTEMV "";                            set XTEM ""
 }

 if {$XTEM==""} {                                 # $INSTPATH/xtem didn't exist up to now, a link to NEW is to be created

   unlink -nocomplain $INSTPATH/xtem
   link -sym $INSTPATH/xtem-$NEWV $INSTPATH/xtem
   set XTEMV "$NEWV";   set XTEM "xtem-$NEWV"
   set OLDV  "";        set OLD  ""

 } else {                                         # $INSTPATH/xtem exists

   if {$XTEMV==""} {                                        # exit if version is not found

     XiProtokoll "\nError - couldn't find xtem version in the start lines of: $INSTPATH/$XTEM/xtem.tcl"
     exit

   }

   if {"$NEWV"!="$XTEMV"} {                                 # XTEMV has to become OLDV

     set OLDV  "$XTEMV";  set OLD  "xtem-$OLDV"
     if {$XLINK} {
       unlink -nocomplain $INSTPATH/xtem
     } else {
       if [file exists $INSTPATH/$OLD] \
	       {signal block SIGCHLD; exec rm -rf $INSTPATH/$OLD; signal unblock SIGCHLD}
       frename $INSTPATH/$XTEM $INSTPATH/$OLD
     }
     link -sym $INSTPATH/$NEW $INSTPATH/xtem
     set XTEMV "$NEWV";   set XTEM "xtem"

   } else {                                                 # no OLD version

     set OLDV  "";        set OLD  ""

   }

 }
 update
 set xtem_path "$INSTPATH/$XTEM"

 set languages "$LANGUAGES"; set Languages ""
 while {[lindex $languages 0]!=""} {
   set langstring [lindex $languages 0]; set languages [lrange $languages 1 end]
   set language [lindex $langstring 0]
   set Languages "$Languages $language" 
 }


 # xtem shell-script creation

 if {[file exists xtem]&&[file exists xtemInstalled]} {
   XiProtokollEnd2 "\nShell script \"xtem\" was not generated as file \"xtemInstalled\" exists."
 } else {
   set f [open "xtem" w]
   puts $f {#!/bin/sh}
   puts $f {}
   puts $f {# generated by xteminstall}
   puts $f {}
   puts $f {# If you need to change this file (e.g. adding environment settings etc.),}
   puts $f {# you can prevent xteminstall from overwriting this file}
   puts $f {# at further calls of xteminstall: }
   puts $f {# just create a file "xtemInstalled" in this directory, eg with Unix command:}
   puts $f {#}
   puts $f {#      touch xtemInstalled}
   puts $f {}
   puts $f {#####  command to call wishx (must include Tcl, Tk and TclX)}
   puts $f "wishcall=\"$WISHCALL\""
   puts $f {}
   puts $f {#####  path in which xtem is installed:}
   puts $f {#####  can be set by the environment variable XTEMPATH; }
   puts $f {#####  if XTEMPATH doesn't exist, it will be set to the following default value:}
   puts $f ": \$\{XTEMPATH=\$\{XTEMPATH-$INSTPATH/xtem\}\}"
   puts $f "#####  (i.e. files      $INSTPATH/xtem/*.tcl     will be found)"
   puts $f {}
   puts $f {#####  one of the following language defining lines must be made active! }
   puts $f {#defaultlanguage="german"}
   puts $f {#defaultlanguage="english"}
   puts $f "defaultlanguage=\"$DEFAULTLANGUAGE\""
   puts $f {}
   puts $f {if [ ! -d "$XTEMPATH" ]}
   puts $f {then}
   puts $f {  echo "error at xtem call:  XTEMPATH=$XTEMPATH   doesn't exist"}
   puts $f {  echo "probably your installation is incomplete, see: xtem Installation Guide)"}
   puts $f {  exit}
   puts $f {fi}
   puts $f {}
   puts $f {if [ "$defaultlanguage" = "" ]}
   puts $f {then}
   puts $f {  defaultlanguage="english"}
   puts $f {  echo "installation incomplete: default language is not specified;  set to $defaultlanguage"}
   puts $f {  echo "please modify file (shell script) \"$0\""}
   puts $f {fi}
   puts $f {}
   puts $f {language=$defaultlanguage}
   puts $f {}
   puts $f {if [ "$1 " = "-l " ] ;# Blanks inserted for Linux}
   puts $f {then language="$2"; shift}
   puts $f {  if [ "$1" = "" ]}
   puts $f {  then}
   puts $f {    echo "syntax:  `basename $0` [ -l language ] [ filename[.tex] ]"}
   puts $f {  else}
   puts $f {    shift}
   puts $f {  fi}
   puts $f {fi}
   puts $f {}
   set languages "$LANGUAGES"; set supported ""; set sep ""; set Languages ""
   while {[lindex $languages 0]!=""} {
     set langstring [lindex $languages 0]; set languages [lrange $languages 1 end]
     set language [lindex $langstring 0];  set synonyms [lrange $langstring 1 end]
     set Languages "$Languages $language" 
     set supported "$supported$sep $language";   set sep ","
     while {[lindex $synonyms 0]!=""} {
       puts $f "if \[ \"\$language\" = \"[lindex $synonyms 0]\" \]; then language=\"$language\"; fi"
       set supported "$supported | [lindex $synonyms 0]"
       set synonyms [lrange $synonyms 1 end]
     }
   }
   puts $f "if \[ \\"
   set languages "$LANGUAGES"
   set a "  "
   foreach i $Languages {puts $f "     $a \"\$language\" != \"$i\" \\";   set a "-a"}
   puts $f {   ]}
   puts $f {then}
   puts $f {  echo "Warning: language \"$language\" not implemented; we use \"$defaultlanguage\" instead"}
   puts $f "  echo \"         supported languages are:  $supported\""
   puts $f {  language=$defaultlanguage}
   puts $f {fi}
   puts $f {}
   puts $f {exec $wishcall -f $XTEMPATH/xtem.tcl -n xtem $wishcall $XTEMPATH $language $*}
   puts $f {####}
   puts $f {}
   close $f
   chmod a+rx xtem
 }

 XiProtokoll "\nInstallation parameters:"
 XiProtokoll "  Directory for installation of xtem_TeXMenu:  $INSTPATH"
 XiProtokoll "  Directory for executeables and shell scripts:  $BINPATH"
 XiProtokoll "  Command to call wishx (Tcl, Tk and TclX):  $WISHCALL"
 XiProtokoll "  Defaultlanguage:  $DEFAULTLANGUAGE"
 XiProtokoll "  Language(s):"
 set languages "$LANGUAGES"
 while {[lindex $languages 0]!=""} {
   set langstring [lindex $languages 0]; set languages [lrange $languages 1 end]
   set language [lindex $langstring 0];  set synonyms [lrange $langstring 1 end]
   if {$synonyms==""} {XiProtokoll "    $language"} else {XiProtokoll "    $language  (synonym(s)): $synonyms)"}
 }
 update

 # installation of shell script  xtem ---> $BINPATH

 signal block SIGCHLD; set cmpres [catch "exec cmp $BINPATH/xtem xtem" cmpmes]; signal unblock SIGCHLD
 if {[file exists "$BINPATH/xtem"]&&($cmpmes=="")} {# is up to date
   XiProtokoll "\nIs up to date: \"xtem\" (Shell script)"
 } else {# must be updated
   if [file writable $BINPATH] {# update can be done
     XiProtokoll "\nInstallation of:  $BINPATH/xtem  (Shell script)"
     unlink -nocomplain $BINPATH/xtem; link -sym $INSTPATH/xtem/xtem $BINPATH/xtem
   } else {# needs update, but cannot be updated!
     XiProtokollEnd1 "\n$BINPATH/xtem [XiNotInstalledText]"
     XiProtokollEnd1 "  rm $BINPATH/xtem\n  ln -s $INSTPATH/xtem/xtem $BINPATH/xtem" ; XiProtokoll ""
   }
 }
 update

 # installation of changecode ---> $BINPATH

 if [file exists "changecode"] {
   signal block SIGCHLD
   set cmpres [catch "exec cmp $BINPATH/changecode changecode" cmpmes]
   signal unblock SIGCHLD
   if {[file exists "$BINPATH/changecode"]&&($cmpmes=="")} {# changecode is up to date
     XiProtokoll "\nIs up to date: \"changecode\""
   } else {# changecode must be updated
     if [file writable $BINPATH] {# update can be done
       XiProtokoll "\nInstallation of:  $BINPATH/changecode"
       unlink -nocomplain $BINPATH/changecode; link -sym $INSTPATH/xtem/changecode $BINPATH/changecode
     } else {# needs update, but cannot be updated!
       XiProtokollEnd1 "\n$BINPATH/changecode [XiNotInstalledText]"
       XiProtokollEnd1 "  rm $BINPATH/changecode\n  ln -s $INSTPATH/xtem/changecode $BINPATH/changecode"; XiProtokoll ""
     }
   }
 } else {# file changecode not found
   XiProtokollEnd1 "\nFile not found: \"changecode\""; XiProtokoll ""
 }
 update


 # man-page installation  xtem.1 ---> $MANPATH

 signal block SIGCHLD
 set cmpres [catch "exec cmp $MANPATH/xtem.1 xtem.1" cmpmes]
 signal unblock SIGCHLD
 if {[file exists "$MANPATH/xtem.1"]&&($cmpmes=="")} {# is up to date
   XiProtokoll "\nIs up to date: \"xtem.1\" (Manual page)"
 } else {# must be updated
   if [file writable $MANPATH] {# update can be done
     XiProtokoll "\nInstallation of:  $MANPATH/xtem.1  (Manual page)"
     unlink -nocomplain $MANPATH/xtem.1; link -sym $INSTPATH/xtem/xtem.1 $MANPATH/xtem.1
   } else {# needs update, but cannot be updated!
     XiProtokollEnd1 "\n$MANPATH/xtem.1 [XiNotInstalledText]"
     XiProtokollEnd1 "  rm $MANPATH/xtem.1\n  ln -s INSTPATH/xtem/xtem.1 $MANPATH/xtem.1"; XiProtokoll ""
   }
 }
 update


 # installation of the setting files

 XiProtokoll "\nPresetting files ($INSTPATH/xtem_locals_*/*.vst):"
 foreach language $Languages {
   set cpFrom ""; set todir "$INSTPATH/xtem_locals_$language"
   if {[file exists $todir]} {                          # already exist's

     if {[file isdirectory $todir]} {                   #              and is directory
       chmod a+rx $todir
       XiProtokoll "\talready existing file is still used:  $todir"
     } else {                                           #              and is no directory
       XiProtokoll "\n  $todir \t exists and is file;"
       XiProtokoll "\t\tshouldn't exist or should be directory --- installation aborted!"
       exit
     }

   } else {                                             # doesn't exist: to be created

     mkdir $todir;  chmod a+rx $todir
     if {$OLDV!=""} {set cpFrom "$INSTPATH/$OLD/locals_$language"} else {set cpFrom "$INSTPATH/$NEW/locals_$language"}
     if {([file type $cpFrom]=="link")&&(![file exists [file readlink $cpFrom]])} \
	     {set cpFrom "$INSTPATH/$NEW/locals_$language.LRW"}
     set res [catch  "glob -- $cpFrom/*.vst" files]
     if {[catch  "glob -- $cpFrom/*.vst" files]} \
	     {set cpFrom "$INSTPATH/$NEW/locals_$language.LRW"; set files [glob -- $cpFrom/*.vst]}
     signal block SIGCHLD; foreach f $files {exec cp $f $todir/.};  signal unblock SIGCHLD
     set files [glob -- $todir/*.vst];   foreach f $files {chmod a+r $f}
     XiProtokoll "\tis created:  $todir"

   }
   if {$cpFrom!=""} {XiProtokoll "\t(files copied from: $cpFrom)"}; set cpFrom ""
   cd locals_$language.LRW; set files "[glob -- *.vst]"; cd ..
   foreach f $files {
     if ![file exists $todir/$f] {
       set cpFrom "locals_$language.LRW/$f"
       signal block SIGCHLD; exec cp $cpFrom $todir/.; signal unblock SIGCHLD
       chmod a+r $todir/$f
     }
     if {$cpFrom!=""} {XiProtokoll "\tfile copied from: $cpFrom"}; set cpFrom ""
   }
   if     {![file exists locals_$language]}      {link -sym $INSTPATH/xtem_locals_$language locals_$language} \
   elseif {[file type locals_$language]=="link"} {unlink -nocomplain locals_$language; link -sym $todir locals_$language}

   set file locals_$language/texfmt.vst;  # test whether texfmt.vst should be updated or not
   XiProtokoll "\nChecking file $file"
   set f [open locals_$language/texfmt.vst]; Xigetscl0 $f e; set s [string index [string trim $e] 0]; Xigetscl0 $f e
   if {[getvalue $e 2 $s]==""} {
     XiProtokollEnd2 "\n  You are recommended to update file `$file'"
     XiProtokollEnd2 "  in order to use the `quick&dirty' facilities; for details see `Installation Guide'"
     XiProtokoll ""
   } else {XiProtokoll "  OK: Quick&Dirty is installed"}

   set file locals_$language/printing.vst;  # test whether printing.vst should be adapted from lp to lpr
   XiProtokoll "\nChecking file $file"
   set f [open $file]; Xigetscl0 $f e; set s [string index [string trim $e] 0]; Xigetscl0 $f e
   if {[string index [string trim $e] 0]=="$s"} {Xigetscl0 $f e}
   set p [getvalue $e 6 $s]
   if {[catch "which $p" m]!=0} {
     XiProtokollEnd2 "\n  File `$file' has default printer: `$p'"
     XiProtokollEnd2 "  This printer (command) is not found on this system."
     XiProtokollEnd2 "  Please check this file; for details see `Installation Guide'"
     XiProtokoll ""
   } else {XiProtokoll "  OK: line printer (command) `$p' is found"}

   set file locals_$language/mkcommand.vst
   # test whether mkcommand.vst has column for this Tcl version or not
   XiProtokoll "\nChecking file $file"
   if [info exists MkcmdTclVColNr] {unset MkcmdTclVColNr}; set mkcmdcol [MkcmdTclVCol no-exit]
   if {$mkcmdcol==0} {
     XiProtokollEnd2 "\n  File `locals_$language/mkcommand.vst' has no column for Tcl version $tclversion"
     XiProtokollEnd2 "  It is necessary to update this file (e.g. by copying it from"
     XiProtokollEnd2 "  locals_$language.LRW/mkcommand.vst); for details see `Installation Guide'"
     XiProtokoll ""
   } else {XiProtokoll "  OK: has entries for executing commands with Tcl version $tclversion"}
   # test whether mkcommand.vst must be updated or not
   vstr_exec no-exit
   if {"$mkcommand"=="mkcommand.9"} {
     XiProtokollEnd2 "\n  File `$file' needs customization;"
     XiProtokollEnd2 "  remove \"... mkcommand.9 ...\" etc., for details see `Installation Guide'"
     XiProtokoll ""
   }

 }
 update


 # installation of the "local.news"

 XiProtokoll "\nLocal News ($INSTPATH/xtem_locals_*/local.news):"
 foreach file "local.news xtemstart.news" {
   foreach language $Languages {
     if ![file exists $INSTPATH/xtem_locals_$language/$file] {
       if [file exists $INSTPATH/$OLD/locals_$language/$file] {set cpFrom "$INSTPATH/$OLD/locals_$language/$file"} \
       else {set cpFrom "locals_$language.LRW/$file"}
       set cpTo "$INSTPATH/xtem_locals_$language/$file"
       signal block SIGCHLD; exec cp $cpFrom $cpTo; signal unblock SIGCHLD;  chmod a+r $cpTo
       XiProtokoll "\tfile copied from:  $INSTPATH/xtem/$cpFrom"
     } else {
       XiProtokoll "\talready existing file is still used:  $INSTPATH/xtem_locals_$language/$file"
     }
   }
 }
 update


 # check (and modify if necessary) variable "xtermcall" in install.vst

 XiProtokoll "\nVariable xtermcall is checked (and modified if necessary) in ($INSTPATH/xtem_locals_*/install.vst):"
 foreach language $Languages {
   set todir "$INSTPATH/xtem_locals_$language"; set xtem_path "$INSTPATH/$NEW"; set XiVstHasSep 0
   if {![file exists $todir/install.vst]} {
     XiProtokoll "\n\tFile not found: $todir/install.vst\n"; mybell 4
   } else {
     set XiCurLanguage $language; set modified 0; set ln 0; XiVst2Lists install.vst ""
     foreach l $XiVstActive {
       if {("z[lindex $l 0]"=="zxtermcall")&&("z[lrange $l 1 end]"!="z$XTERMCALL")} {
         set XiVstActive [linsert [lreplace $XiVstActive $ln $ln "#$l"] [expr $ln+1] "xtermcall          $XTERMCALL"]
         set modified 1; incr ln; #incr ln important at this place (if more than one xtermcall line!)
       }
       incr ln
     }
     if {$modified==1} {XiSaveVstfile install.vst 1}
   }
 }
 update


 # delete existing language-dependent directories for languages not included in $LANGUAGES
 #
 # at the moment no real delete, but creatiion of a list of commands to delete them

 foreach langex "[glob -- help_*]" {
   set lgex [crange $langex 5 end];  set unused 1
   foreach lang $Languages {if {$lgex=="$lang"} {set unused 0}}
   if {$unused} {
     XiProtokoll "\n$lang :\tlanguage-dependent files are unused (~ 1 MB disk space/language!),"
     XiProtokoll "\t\tuse the following command to delete these files:"
     XiProtokoll "\t\t  rm -rf $INSTPATH/$NEW/*_$lang "}
 }
 update


 # chmod's

 XiProtokoll "\n\nSetting acces modes:\n"
 set mod "a+r";  set names "$INSTPATH/$NEW                     "; XiChmod $mod "$names"
 set mod "a+r";  set names "$INSTPATH/$NEW/*                   "; XiChmod $mod "$names"
 set mod "a+r";  set names "$INSTPATH/$NEW/*/*                 "; XiChmod $mod "$names"
 set mod "a+r";  set names "$INSTPATH/$NEW/*/*/*               "; XiChmod $mod "$names"
 set mod "a+rx"; set names "$INSTPATH/$NEW                     "; XiChmod $mod "$names"
 set mod "a+rx"; set names "$INSTPATH/$NEW/xtem                "; XiChmod $mod "$names"
 set mod "a+rx"; set names "$INSTPATH/$NEW/xtem.tcl            "; XiChmod $mod "$names"
 set mod "a+rx"; set names "$INSTPATH/$NEW/xtem_*              "; XiChmod $mod "$names"
 set mod "a+rx"; set names "$INSTPATH/$NEW/locals_*            "; XiChmod $mod "$names"
 set mod "a+rx"; set names "$INSTPATH/$NEW/help_*              "; XiChmod $mod "$names"
 set mod "a+rx"; set names "$INSTPATH/$NEW/help_*/latex        "; XiChmod $mod "$names"
 set mod "a+rx"; set names "$INSTPATH/$NEW/help_*/miscellaneous"; XiChmod $mod "$names"


 # all programs accessable?

 if {$whichcheck=="yes"} {
   XiProtokoll "\n\nCheck whether the programs in the standard setting files are installed or not:\n"
   set ProgramList(editor.vst)          "emacs       vi"
   set ProgramList(texfmt.vst)          "tex         latex       latex209"
   set ProgramList(previewer.vst)       "ghostview   xdvi        tkdvi"
   set ProgramList(printing.vst)        "dvips       dvijep      lp"
   set ProgramList(prt_dvips.tcl)       "dvidvi"
   set ProgramList(spellcheck.vst)      "spell       ispell"
   set ProgramList(syntax.vst)          "texchk      lacheck"
   set ProgramList(index.vst)           "makeindex"
   set ProgramList(bibtex.vst)          "bibtex"
   set ProgramList(logform.vst)         "cat         pg          emacs       vi"
   set ProgramList(utility.vst)         "changecode  xfig"
   set ProgramList(tl.tcl)              "gunzip      xdvi"

   foreach pln [array names ProgramList] {
     foreach program "$ProgramList($pln)" {
       set not_installed [catch "which $program"  m1]
       if $not_installed {XiProtokoll "[XiFillString $program 30] *** warning: not found, yet can be called via: $pln"} \
       else		 {XiProtokoll "[XiFillString $m1      30]              program found, can be called via: $pln"}
     }
   }
   update
 }


 # test for gunzip | xdvi

 if {$whichcheck=="yes"} {
   set gunzip_not_installed [catch "which gunzip"  m1]
   set xdvi_not_installed   [catch "which xdvi" m2]
   if {$gunzip_not_installed && $xdvi_not_installed } {
     XiProtokoll "\n$XV(AAsteriks)\nNone of the following programs is installed: gunzip | xdvi"
     XiProtokoll "Sorry, you can't display the bitmaps to the (La)TeX syntax examples, see Installation Guide!"
     XiProtokoll "$XV(AAsteriks)\n"
   }
 }

 #puts stdout "**** fehlt noch bei Installation: Installation weiterer Sprachen vorber.        "; #####@@@@@
 #puts stdout "**** fehlt noch bei Installation: welche Buttons im Hauptmenu erzeugen?         "; #####@@@@@
 #puts stdout "**** fehlt noch bei Installation: alte help-files Vorrang vor neuen?            "; #####@@@@@
 #puts stdout "**** fehlt noch bei Installation: character set translation (umlaute)           "; #####@@@@@
 #puts stdout "**** fehlt noch bei Installation: Bitmap-Dateien: *.gz oder *.xbm lschen!      "; #####@@@@@

 if {$XiProtEndText1!=""} {
   mybell 4
   XiProtokoll "\n\n$XV(AAsteriks)\n$XV(AAsteriks)\n$XiProtEndText1"
   XiProtokoll "Installation procedure ended incompletely (see preceding messages)!"
   XiProtokoll "Restart xteminstall after execution of the commands given ahead"
   XiProtokoll "or restart xteminstall with write permission (e.g. as superuser)."
   if {$XiProtEndText2!=""} {XiProtokoll "\n$XiProtEndText2"}
   XiProtokoll "$XV(AAsteriks)\n$XV(AAsteriks)"
   foreach b ".a.ende" {$b configure -state normal}; update
 } else {
   XiProtokoll "\nInstallation procedure ended correctly.\nYou can now test and modify the setting files!"
   if {$XiProtEndText2!=""} {XiProtokoll "\n$XiProtEndText2"}
   foreach b ".a.ende .a.inst .a.vsts" {$b configure -state normal}; update
 }
 set XiProtEndText1 ""; set XiProtEndText2 ""
}


#---------------------------------------------------------------------------------------------

#----- setting file select menu proc's -------------------------------------------------------

proc XiFilesLangSuffix {suffix} {
 global XV Wvsts INSTPATH LANGUAGES NEW email
 TestPut 2 ""

 set lstr "$LANGUAGES"; set Languages ""
 while {[lindex $lstr 0]!=""} {set Languages "$Languages [lindex [lindex $lstr 0] 0]"; set lstr [lrange $lstr 1 end]}
 set files ""
 foreach lang $Languages {
   if {![file exists $INSTPATH/$NEW/locals_$lang]} {
     XiProtokoll "$INSTPATH/$NEW/locals_$lang : directory not found;\nclick at \"install xtem\" first."
     XiProtokoll "If this error then repeats: $email\n"
     mybell 4
     return "$XV(anever)"
   }
   set list [glob -- $INSTPATH/$NEW/locals_$lang/*$suffix]
   foreach name $list {
     set name [crange $name [string last "/" $name]+1 end-[string length $suffix]]
     set isin 0; foreach f $files {if {$name=="$f"} {set isin 1}}; if !$isin {set files "$files $name"}
   }
 }
 return "[lsort $files]"
}

proc XiCreateFileEditButtons {W Files Suffix Text} {
 TestPut 2 ""
 frame $W.dummy -height 7; pack $W.dummy -side top -anchor w
 label $W.label -text "$Text:"; pack $W.label -side top -anchor w -pady 3
 set line 1
 while {$Files!=""} {
   frame $W.frame$line; pack $W.frame$line -side top -anchor nw
   for {set n 1} {$n<=4} {incr n} {
     set fn [lindex $Files 0]; set Files [lrange $Files 1 end]
     button $W.frame$line.$fn -width 15 -text "$fn$Suffix" -anchor w -command "XiSettEditNV $fn $Suffix"
     pack $W.frame$line.$fn -side left
     if {$Files==""} {break}
   }
   incr line
 } 
}

proc XiSettEditNV {f s} {TestPut 2 ""; if {$s==".news"} {XiSettEditNews $f} else {XiSettEditVst $f}}

proc XiActivateFileEditButtons {W Files Suffix ActivateCase} {
 global XV INSTPATH NEW XiCurLanguage
 TestPut 2 ""
 set line 1
 while {$Files!=""} {
   for {set n 1} {$n<=4} {incr n} {
     set fn [lindex $Files 0]; set Files [lrange $Files 1 end]
     if     {$ActivateCase==0} {$W.frame$line.$fn configure -state disabled} \
     elseif [file exists $INSTPATH/$NEW/locals_$XiCurLanguage/$fn$Suffix] {$W.frame$line.$fn configure -state normal} \
     else                      {$W.frame$line.$fn configure -state disabled}
     if {$Files==""} {break}
   }
   incr line
 } 
}

proc XiLangButton {language} {
 global Wvsts XV INSTPATH NEW XiNewsfiles XiVstfiles
 TestPut 2 ""
 if {[file type "$INSTPATH/$NEW/locals_$language"]=="link"} \
      {set t1 "Directory: is link -->"; set t2 "[file readlink $INSTPATH/$NEW/locals_$language]"} \
 else {set t1 "Directory:";             set t2 "$INSTPATH/$NEW/locals_$language"}
 ConfigText $Wvsts.a.dirs.text "$t1"; ConfigText $Wvsts.a.dirs.disp "$t2"
 XiActivateFileEditButtons $Wvsts.b "$XiNewsfiles" .news 1
 XiActivateFileEditButtons $Wvsts.c "$XiVstfiles"  .vst  1
}

#----- setting file select menu        -------------------------------------------------------

proc XiSettings {} {

 global XV Wvsts INSTPATH LANGUAGES DEFAULTLANGUAGE NEW XiCurLanguage XiNewsfiles XiVstfiles
 TestPut 3 "**********************"

 XiProtokoll "$XV(AAsteriks)\nModification of the setting files ...\n"

 set lstr "$LANGUAGES"; set Languages ""
 while {[lindex $lstr 0]!=""} {set Languages "$Languages [lindex [lindex $lstr 0] 0]"; set lstr [lrange $lstr 1 end]}
 set XiNewsfiles [XiFilesLangSuffix .news];  set XiVstfiles [XiFilesLangSuffix .vst]
 if {($XiNewsfiles=="$XV(anever)")||($XiVstfiles=="$XV(anever)")} {return}


 foreach b ".a.ende .a.inst .a.vsts" {$b configure -state disabled}; update idletasks

 toplevel_init $Wvsts "Modification of Settings" 0 0

 frame $Wvsts.a -borderwidth 1 -relief raised; pack $Wvsts.a -side top -fill x
 frame $Wvsts.b -borderwidth 1 -relief raised; pack $Wvsts.b -side top -fill x -ipady 3
 frame $Wvsts.c -borderwidth 1 -relief raised; pack $Wvsts.c -side top -fill x -ipady 3


 # frame a: end button, languagage selecton and directory display

 button $Wvsts.a.ende -text "end" \
   -command {foreach b ".a.ende .a.inst .a.vsts" {$b configure -state normal}; update idletasks; destroy $Wvsts; raise .}
 label  $Wvsts.a.dum1 -width 2;  pack $Wvsts.a.ende $Wvsts.a.dum1 -side left

 set XiCurLanguage $DEFAULTLANGUAGE
 frame $Wvsts.a.lang -height 300; pack $Wvsts.a.lang -side left
 label $Wvsts.a.lang.label -text "Language selection:"
 pack $Wvsts.a.lang.label -side top
 foreach l $Languages {
   radiobutton $Wvsts.a.lang.$l -variable XiCurLanguage -value $l -width 14 -text $l -anchor w -command "XiLangButton $l"
   pack $Wvsts.a.lang.$l -side top -anchor w
 }

 label $Wvsts.a.dum2 -width 2;    pack $Wvsts.a.dum2 -side left
 frame $Wvsts.a.dirs -height 300; pack $Wvsts.a.dirs -side left
 if {[file type "$INSTPATH/$NEW/locals_$XiCurLanguage"]=="link"} \
      {set t1 "Directory: is link -->"; set t2 "[file readlink $INSTPATH/$NEW/locals_$XiCurLanguage]"} \
 else {set t1 "Directory:";             set t2 "$INSTPATH/$NEW/locals_$XiCurLanguage"}
 label $Wvsts.a.dirs.text -text "$t1"; pack $Wvsts.a.dirs.text -side top -anchor w
 label $Wvsts.a.dirs.disp -text "$t2"; pack $Wvsts.a.dirs.disp -side top -anchor w


 # frame b: news file buttons

 XiCreateFileEditButtons $Wvsts.b $XiNewsfiles .news "News Files"
 XiActivateFileEditButtons $Wvsts.b $XiNewsfiles .news 1


 # frame c: setting file buttons

 XiCreateFileEditButtons $Wvsts.c $XiVstfiles .vst "Setting Files"
 XiActivateFileEditButtons $Wvsts.c $XiVstfiles .vst 1
}

#---------------------------------------------------------------------------------------------

#----- setting file edit menus proc's --------------------------------------------------------

proc XiSaveNewsfile {W FileSuffix} {
 global XV INSTPATH NEW XiCurLanguage
 TestPut 2 ""
 set file $INSTPATH/$NEW/locals_$XiCurLanguage/$FileSuffix
 set f [open $file w]
 set lc [$W.b.t get "end -1c" end]
 if {($lc=="\n")} {puts -nonewline $f [$W.b.t get 1.0 "end-1c"]} \
 else             {puts -nonewline $f [$W.b.t get 1.0 end]}
 flush $f;  close $f
 XiProtokoll "\tsave file \"$file\""
}

proc XiSaveVstfile {FileSuffix protocol} {
 global XV INSTPATH NEW XiCurLanguage XiVstActive XiVstInactive XiVstHasSep XiVstFL
 TestPut 2 ""
 set file $INSTPATH/$NEW/locals_$XiCurLanguage/$FileSuffix
 set f [open $file w]
 if {$XiVstHasSep} {puts $f "$XiVstFL"}
 if {$XiVstHasSep} {set pnl " \\\n"} else {set pnl ""}
 foreach l $XiVstActive {puts $f "$l$pnl"}
 puts $f "\n$XV(XSettVCom$XiCurLanguage)\n"
 foreach l $XiVstInactive {puts $f "$l$pnl"}
 flush $f;  close $f
 if $protocol {XiProtokoll "\tsave file \"$file\""}
}

proc XiSaveFile {W File Suffix} {
 TestPut 2 ""
 if {$Suffix==".news"} {XiSaveNewsfile $W $File$Suffix} {XiSaveVstfile $File$Suffix 1}
}

proc XiDestroyESBut {W File Suffix logtext} {
 global Wvsts XiNewsfiles XiVstfiles
 TestPut 2 ""
 if {$File!=""} {if {$Suffix==".news"} {XiSaveNewsfile $W $File$Suffix} else {XiSaveVstfile $File$Suffix 1}}
 XiProtokoll "$logtext"
 destroy $W; raise $Wvsts
 XiActivateFileEditButtons $Wvsts.b $XiNewsfiles .news 1; XiActivateFileEditButtons $Wvsts.c $XiVstfiles .vst 1
 $Wvsts.a.ende configure -state normal; update idletasks
}

proc XiCreateESButtons {W File Suffix} {
 global XV
 TestPut 2 "<$W><$File><$Suffix>"
 if [info exists XV(XSettVF$File$Suffix)] {TestPut 2 "$XV(XSettVF$File$Suffix)"}
 button $W.a.ends -text "end with file save" -command "XiDestroyESBut $W $File $Suffix \"end with file save\""
 pack $W.a.ends -side left
set XV(aendq)     ""
 button $W.a.save -text "save file" -command "XiSaveFile $W $File $Suffix"; pack $W.a.save -side left
 button $W.a.endq -text "exit without file save" -command "XiDestroyESBut $W \"\" $Suffix exit"
 pack $W.a.endq -side left
}

proc XiCreateLSBox {w text s wi he bw list com} {
# creates frame w.f and title for selection, creates selection box + scrollbar, width wi, height he;  fills with list
 global XiVstLastClick
 TestPut 2 ""

 frame $w.f; pack configure $w.f -anchor sw -padx 2 -pady 8
 if {$text!=""} {label $w.f.l -text $text; pack configure $w.f.l -side $s -anchor w}
 frame $w.f.f -relief raised -borderwidth $bw; pack configure $w.f.f -anchor sw
 scrollbar $w.f.f.sb -command "$w.f.f.li yview"
 listbox $w.f.f.li -yscrollcommand "$w.f.f.sb set" -width $wi -height $he
 pack configure $w.f.f.sb $w.f.f.li -side right -fill y
 if {$list!=""} then {foreach e $list {$w.f.f.li insert end $e}}
 bind $w.f.f.li <Leave> Bend;  bind $w.f.f.li <Double-Button-1> Bend;  bind $w.f.f.li <Triple-Button-1> Bend
 bind $w.f.f.li <Button-1> "set XiVstLastClick \[Selektion %W %y\]; $com; Bend"
}

proc Xigetscl0 {foid e} {# like getscl, but blanks at begin-of-continuation-line deleted
 upvar 1 $e ein
 TestPut 1 ""
 set ret [gets $foid z];  set z [string trimright $z]
 set ein "$z"
 set lm1 [expr [string length $z]-1]
 while {($lm1>=0)&&([string last \\ $z]==$lm1)} { 
   set ein [string range $ein 0 [expr [string length $ein]-2]]
   set ret [gets $foid z];  set z [string trimright $z]
   set lm1 [expr [string length $z]-1]
   set ein "$ein[string trimleft $z]"
 }
 if {$ret>=0} {set ret [string length "$ein"]}; return $ret
}

proc XiVst2Lists {file tmp} {# read vst-file, store as lists in XiVstActive/Inactive
 global XV XiCurLanguage XiVstActive XiVstInactive XiVstSep XiNoSepVstFiles XiVstHasSep XiVstFL XiVstDefLine XiVstParAnz
 global tclversion
 TestPut 2 "<$file><$tmp>"
 set XiNoSepVstFiles "install.vst logsuffix.vst suffix.vst texsuffix.vst"
 set XiVstHasSep 1; foreach f $XiNoSepVstFiles {if {$file=="$f"} {set XiVstHasSep 0}}
 set XiVstActive "";  set XiVstInactive ""; set active 1; set XiVstDefLine ""; set XiVstFL ""; set XiVstSL ""
 if [regexp {prt_.+\.vst$} $file] {set XV(XSettVF$file) $XV(XSettVFprt_dvi2xyz.vst)}
 if {$tmp=="tmp"} {set filename "${file}.tmp"} else {set filename "$file"}
 if {"$file"=="mkcommand.vst"} \
     {global MkcmdTclVColNr; if [info exists MkcmdTclVColNr] {unset MkcmdTclVColNr}; set mkcmdcol [MkcmdTclVCol no-exit]}
 set f [open_vst $filename]
 if $XiVstHasSep {Xigetscl0 $f e;set XiVstSep [string index [string trim $e] 0];set XiVstFL "$e"} else {set XiVstSep ""}
 if {[lindex $XV(XSettVF$file) 3]==0} {# user cannot define parameters in this file
   set XiVstParAnz [lindex $XV(XSettVF$file) 2]
 } else {			       # user can define parameters in this file
   set XiVstParAnz [expr [llength [split $XiVstFL $XiVstSep]]-1]
   if {[lindex [split $XiVstFL $XiVstSep] $XiVstParAnz]==""} {incr XiVstParAnz -1}
   set liste [split $XiVstFL $XiVstSep]; set XiVstFL "[lindex $liste 0]"
   for {set n 1} {$n<=$XiVstParAnz} {incr n} \
	   {regsub -all " " [string trim [lindex $liste $n]] "_" zz;  set XiVstFL "$XiVstFL$XiVstSep $zz "}
 }
 if {[lindex $XV(XSettVF$file) 1]==1} {# criteria line expected in this file
   Xigetscl0 $f e;  set XiVstSL "$e"
   if {[string trim [lindex [split $e $XiVstSep] 0]]!=""} {# no defaults for the criteria line (e.g. printing.vst) found
     set XiVstSL "          "; set liste [split $XiVstFL $XiVstSep]
     for {set n 1} {$n<=$XiVstParAnz} {incr n} {
	set XiVstSL "$XiVstSL$XiVstSep"
	if {[string trim [lindex $liste $n]]!=""} {set XiVstSL "${XiVstSL} * "} \
	else					  {set XiVstSL "${XiVstSL}[lindex $liste $n]"}
     }
     lappend XiVstActive $XiVstSL
     lappend XiVstActive $e
   } else {						   # defaults for the criteria line (e.g. printing.vst) found
     lappend XiVstActive $e
   }
 }
 if {("$file"=="mkcommand.vst")&&($mkcmdcol==0)} {set XiVstFL "$XiVstFL $XiVstSep Tcl_$tclversion"; incr XiVstParAnz}
 set ln 0
 while {[Xigetscl0 $f e]>=0} {
   incr ln
   set l [string length $e]; set p [string first "$XV(XSettVCom$XiCurLanguage)" $e]
   if {("$file"=="mkcommand.vst")&&($mkcmdcol==0)} {set e "$e $XiVstSep"; if {$ln==1} {set e "$e mkcommand.9"}}
   if     {($l> 0)&&($active)} {lappend XiVstActive $e} \
   elseif {($l==0)&&($active)} {set active 0} \
   elseif {($l> 0)&&($p<0)}    {lappend XiVstInactive $e}
 }
 close $f
 set XV(XSettVF$file) [lreplace $XV(XSettVF$file) 7 7 $XiVstParAnz]
 for {set n 1} {$n<=$XiVstParAnz} {incr n} {set XiVstDefLine "$XiVstDefLine $XiVstSep"}
}


proc XiSettVHCritLine {} {# if item XiVstSelectedNr is criterion line in XiVstActive: return 1 (else 0)
 global XV XiSelectedFromActive XiVstSelectedNr XiSelectedVstFile
 TestPut 2 ""
 if {($XiSelectedFromActive==1)&&($XiVstSelectedNr<[lindex $XV(XSettVF$XiSelectedVstFile) 1])} {return 1} {return 0}
}

proc XiSettVHDel {deleteitemnumber} {# delete deleteitemnumber from XiVstActive/XiVstInactive acc.to XiSelectedFromActive
 global XV Wevst XiSelectedFromActive XiVstActive XiVstInactive
 TestPut 2 ""
 if {$deleteitemnumber==""} {return}
 if {$XiSelectedFromActive==1} {
   if {[string length [lindex $XiVstActive $deleteitemnumber]]==0} \
	{ConfigText $Wevst.e.t "you can't delete from an empty list!"; mybell 4; return}
   set XiVstActive   [lreplace "$XiVstActive"   $deleteitemnumber $deleteitemnumber]
 } else {
   if {[lindex $XiVstInactive $deleteitemnumber]==""} \
	{ConfigText $Wevst.e.t "you can't delete from an empty list!"; mybell 4; return}
   set XiVstInactive [lreplace "$XiVstInactive" $deleteitemnumber $deleteitemnumber]
 }
}

proc XiSettVHFill {} {# fill lists XiVstActive and XiVstInactive into their windows
 global Wevst XiVstActive XiVstInactive
 TestPut 2 ""
 $Wevst.b.f.f.li delete 0 end; foreach e $XiVstActive   {$Wevst.b.f.f.li insert end $e}
 $Wevst.c.f.f.li delete 0 end; foreach e $XiVstInactive {$Wevst.c.f.f.li insert end $e}
}

proc XiSettVHIns {liste nr item} {# insert item as element nr in liste (Active/Inactive)
 global XV Wevst XiVstActive XiVstInactive XiSelectedFromActive
 TestPut 2 ""
 if {$liste==""} {if {$XiSelectedFromActive==1} {set liste "Active"} else {set liste "Inactive"}}
 if     {$liste=="Active" }  {set XiVstActive   [linsert "$XiVstActive"   $nr "$item"]} \
 elseif {$liste=="Inactive"} {set XiVstInactive [linsert "$XiVstInactive" $nr "$item"]} \
 else                        {puts stdout "error in XiSettVHIns"; mybell 4}
}

proc XiSettVHSelClear {} {# clears seclection in both lists XiVstActive and XiVstInactive
 global Wevst XiSelectedFromActive XiVstSelectedNr XiVstLastClick
 TestPut 2 ""
 $Wevst.b.f.f.li selection clear 0 end; $Wevst.b.f.f.li selection clear 0 end
 set XiSelectedFromActive "";  set XiVstSelectedNr "";  set XiVstLastClick ""
}

proc XiSettVHParAddL {ltype liste} {# adds (appends) new parameter to each entry in liste
 global XV XiVstSep XiVstParAnz XiVstParNew
 TestPut 2 ""
 set Liste ""
 foreach e $liste {
   set fl [split $e $XiVstSep];  set fll [llength $fl];  set e "[lindex $fl 0]"
   if {$XiVstParAnz<=$fll} {
     for {set n 1} {$n<$XiVstParAnz} {incr n} {set e "${e}${XiVstSep}[lindex $fl $n]"}
     set e "${e}${XiVstSep} "
     if {($ltype=="Active")&&[lindex $XV(XSettVFprinting.vst) 1]&&([string trim [lindex $fl 0]]=="")} {set e "${e}* "}
   }
   lappend Liste $e
 }
 return "$Liste"
}

proc XiSettVHParDelN {pardel liste} {# delete parameter pardel from each entry in liste
 global XV XiVstSep XiVstParAnz
 TestPut 2 ""
 set Liste ""
 foreach e $liste {
   set fl [split $e $XiVstSep];  set fll [llength $fl];  set e "[lindex $fl 0]"
   if {$pardel<$fll} {set fl [lreplace $fl [expr $pardel-1] $pardel [lindex $fl [expr $pardel-1]]]}
   for {set n 1} {$n<=$XiVstParAnz} {incr n} {if {$n<$fll} {set e "$e$XiVstSep[lindex $fl $n]"}}
   lappend Liste $e
 }
 return "$Liste"
}

proc XiSettVHParList {} {# sets and returns XiVstParAktEL: list of user definable parameters (e.g. in printing.vst)
 global XV XiVstSep XiVstParAnzMin XiVstParAktEL XiVstFL XiVstParAnz
 TestPut 2 ""
 set XiVstParAktEL "";  if {$XiVstParAnz<=$XiVstParAnzMin} {return ""}
 for {set i [expr $XiVstParAnzMin+1]} {$i<=$XiVstParAnz} {incr i} \
	 {lappend XiVstParAktEL "parameter $i :     [lindex [split $XiVstFL $XiVstSep] $i]"}
 return "$XiVstParAktEL"
}

proc XiSettVHSelItem {liste nr} {# marks item nr in XiVstActive/Inactive acc.to liste, update XiVstLastClick
 global Wevst XiSelectedFromActive XiVstLastClick XiVstActive XiVstInactive XiVstSelectedNr
 TestPut 2 ""
 if {$liste==""} {if {$XiSelectedFromActive==1} {set liste "Active"} else {set liste "Inactive"}} 
 if {$liste=="Active"} {set w $Wevst.b.f.f.li; set lst $XiVstActive;   set XiSelectedFromActive 1}  \
 else                  {set w $Wevst.c.f.f.li; set lst $XiVstInactive; set XiSelectedFromActive 0}
 $w yview $nr
 $w selection set $nr
 set XiVstLastClick [lindex $lst $nr]; set XiVstSelectedNr $nr
}

proc XiSettVHSelLineActive   {} {
 global Wevstl XiSelectedFromActive
 TestPut 2 ""
 if [winfo exists $Wevstl] return; set XiSelectedFromActive 1; XiSettVHSelLine
}

proc XiSettVHSelLineInactive {} {
 global Wevstl XiSelectedFromActive
 TestPut 2 ""
 if [winfo exists $Wevstl] return; set XiSelectedFromActive 0; XiSettVHSelLine
}

proc XiSettVHSelLine {} {
 global XiVstLastClick XiSelectedFromActive XiVstActive XiVstInactive XiVstSelectedNr email
 TestPut 2 ""
 if {[string length "$XiVstLastClick"]==0} {return}
 if {$XiSelectedFromActive} {set liste $XiVstActive} else {set liste $XiVstInactive}
 set nr 0; foreach e $liste {if {([string first "$XiVstLastClick" [lindex $liste $nr]]>=0)} {break}; incr nr}
 set XiVstSelectedNr $nr
}


proc XiSettVBAppdNewE  {b} {# create (append) a new active entry and edit this entry
 global XV Wevst XiSelectedFromActive XiVstDefLine XiVstActive XiVstLastClick
 TestPut 2 ""
 set p [llength $XiVstActive];  XiSettVHIns Active $p "$XiVstDefLine"
 XiSettVHFill;  XiSettVHSelItem Active $p;  XiSettVHEditEntry $p
}

proc XiSettVBCopyAct {b} {# copy item XiVstSelectedNr from list XiVstInactive to list XiVstActive
 global XV Wevst XiSelectedFromActive XiVstActive XiVstLastClick
 TestPut 2 ""
 if {$XiSelectedFromActive==""} {ConfigText $Wevst.e.t "$XV(anoentry)";   mybell 4; return}
 if {$XiSelectedFromActive==1}  {ConfigText $Wevst.e.t "$XV(anoinact)";   mybell 4; return}
 set p [llength $XiVstActive];  XiSettVHIns Active $p "$XiVstLastClick";  XiSettVHFill;  XiSettVHSelItem Active $p
 ConfigText $Wevst.e.t "[lindex $XV(XSettVBut$b) 3]"
}

proc XiSettVBCopyInact {b} {# copy item XiVstSelectedNr from list XiVstActive to list XiVstInactive
 global XV Wevst XiSelectedFromActive XiVstInactive XiVstLastClick
 TestPut 2 ""
 if {$XiSelectedFromActive==""} {ConfigText $Wevst.e.t "$XV(anoentry)";  mybell 4; return}
 if {$XiSelectedFromActive==0}  {ConfigText $Wevst.e.t "$XV(anoact)";    mybell 4; return}
 if [XiSettVHCritLine]          {ConfigText $Wevst.e.t "$XV(anocopy)";   mybell 4; return}
 set p [llength $XiVstInactive];  XiSettVHIns Inactive $p "$XiVstLastClick";  XiSettVHFill;  XiSettVHSelItem Inactive $p
 ConfigText $Wevst.e.t "[lindex $XV(XSettVBut$b) 3]"
}

proc XiSettVBCpEdEntry {b} {# copy the selected active entry XiVstLastClick/XiSelectedFromActive and edit the copy
 global XV Wevst XiSelectedFromActive XiVstSelectedNr XiVstLastClick XiVstActive
 TestPut 2 ""
 if {$XiSelectedFromActive==""} {ConfigText $Wevst.e.t "$XV(anoentry)";  mybell 4; return}
 if {$XiSelectedFromActive==0}  {ConfigText $Wevst.e.t "$XV(anoact)";    mybell 4; return}
 if [XiSettVHCritLine]          {ConfigText $Wevst.e.t "$XV(anocopy)";   mybell 4; return}
 set p [expr $XiVstSelectedNr+1];  XiSettVHIns "" $p "$XiVstLastClick";  XiSettVHFill;  XiSettVHSelItem Active $p
 XiSettVHEditEntry $p
}

proc XiSettVBDeltEntry {b} {# delete item XiVstSelectedNr from list XiVstActive/Inactive acc.to XiSelectedFromActive
 global XV Wevst XiSelectedFromActive XiVstLastClick XiVstActive XiVstInactive XiVstSelectedNr
 TestPut 2 "<$b> <$XiSelectedFromActive><[XiSettVHCritLine]><$XiVstSelectedNr>"
 if {$XiSelectedFromActive==""} {ConfigText $Wevst.e.t "$XV(anoentry)";  mybell 4; return}
 if [XiSettVHCritLine]          {ConfigText $Wevst.e.t "$XV(anodelete)"; mybell 4; return}
 if {$XiVstSelectedNr==""} {return}
 XiSettVHDel $XiVstSelectedNr;  XiSettVHFill;  XiSettVHSelClear
 ConfigText $Wevst.e.t "[lindex $XV(XSettVBut$b) 3]"
}

proc XiSettVBEditEntry {b} {# edit the selected active entry XiVstLastClick (XiVstSelectedNr/...)
 global XV Wevst XiSelectedFromActive XiVstSelectedNr
 TestPut 2 ""
 if {$XiSelectedFromActive==""} {ConfigText $Wevst.e.t "$XV(anoentry)";  mybell 4; return}
 if {$XiSelectedFromActive==0}  {ConfigText $Wevst.e.t "$XV(anoact)";    mybell 4; return}
 set p $XiVstSelectedNr;  XiSettVHSelItem Active $p;  XiSettVHEditEntry $p
 ConfigText $Wevst.e.t "[lindex $XV(XSettVBut$b) 3]"
}

proc XiSettVBMakeActiv {b} {# move item XiVstSelectedNr from list XiVstInactive to list XiVstActive
 global XV Wevst XiSelectedFromActive XiVstActive XiVstSelectedNr XiVstLastClick
 TestPut 2 ""
 if {$XiSelectedFromActive==""} {ConfigText $Wevst.e.t "$XV(anoentry)";  mybell 4; return}
 if {$XiSelectedFromActive==1}  {ConfigText $Wevst.e.t "$XV(anoinact)";  mybell 4; return}
 set p [llength $XiVstActive];  XiSettVHIns Active $p "$XiVstLastClick";  XiSettVHDel $XiVstSelectedNr
 XiSettVHFill;  XiSettVHSelItem Active $p
ConfigText  $Wevst.e.t "[lindex $XV(XSettVBut$b) 3]"
}

proc XiSettVBMakeInact {b} {# move item XiVstSelectedNr from list XiVstActive to list XiVstInactive
 global XV Wevst XiSelectedFromActive XiVstInactive XiVstSelectedNr XiSelectedVstFile XiVstLastClick
 TestPut 2 ""
 if {$XiSelectedFromActive==""} {ConfigText $Wevst.e.t "$XV(anoentry)";  mybell 4; return}
 if {$XiSelectedFromActive==0}  {ConfigText $Wevst.e.t "$XV(anoact)";    mybell 4; return}
 if [XiSettVHCritLine]          {ConfigText $Wevst.e.t "$XV(anomove)";   mybell 4; return}
 set p [llength $XiVstInactive];  XiSettVHIns Inactive $p "$XiVstLastClick"; XiSettVHDel $XiVstSelectedNr
 XiSettVHFill;  XiSettVHSelItem Inactive $p
 ConfigText $Wevst.e.t "[lindex $XV(XSettVBut$b) 3]"
}

proc XiSettVBMove1Down {b} {# move item XiVstSelectedNr 1 down in list XiVstActive/Inactive acc.to XiSelectedFromActive
 global XV Wevst XiSelectedFromActive XiSelectedVstFile XiVstSelectedNr XiVstActive XiVstInactive XiVstLastClick
 TestPut 2 ""
 if {$XiSelectedFromActive==1}       {set ll [llength $XiVstActive]} else {set ll [llength $XiVstInactive]}
 if {$XiSelectedFromActive==""}      {ConfigText $Wevst.e.t "$XV(anoentry)";  mybell 4; return}
 if {$XiVstSelectedNr>=[expr $ll-1]} {ConfigText $Wevst.e.t "$XV(anomovedo)"; mybell 4; return}
 if {($XiSelectedFromActive==1)&&($XiVstSelectedNr<=[expr [lindex $XV(XSettVF$XiSelectedVstFile) 1]-1])} \
				     {ConfigText $Wevst.e.t "$XV(anomove)"; mybell 4; return}
 set p $XiVstSelectedNr; XiSettVHDel $p; incr p; XiSettVHIns "" $p "$XiVstLastClick"; XiSettVHFill; XiSettVHSelItem "" $p
 ConfigText $Wevst.e.t "[lindex $XV(XSettVBut$b) 3]"
}

proc XiSettVBMove1Up   {b} {# move item XiVstSelectedNr 1 up in list XiVstActive/Inactive acc.to XiSelectedFromActive
 global XV Wevst XiSelectedFromActive XiSelectedVstFile XiVstSelectedNr XiVstLastClick
 TestPut 2 ""
 if {$XiSelectedFromActive==""} {ConfigText $Wevst.e.t "$XV(anoentry)";  mybell 4; return}
 if {$XiVstSelectedNr<=0}       {ConfigText $Wevst.e.t "$XV(anomoveup)"; mybell 4; return}
 if {($XiSelectedFromActive==1)&&($XiVstSelectedNr<=[lindex $XV(XSettVF$XiSelectedVstFile) 1])} \
				{ConfigText $Wevst.e.t "$XV(anomoveup)"; mybell 4; return}
 set p $XiVstSelectedNr; XiSettVHDel $p; decr p; XiSettVHIns "" $p "$XiVstLastClick"; XiSettVHFill; XiSettVHSelItem "" $p
 ConfigText $Wevst.e.t "[lindex $XV(XSettVBut$b) 3]"
}

proc XiSettVBMoveDeflt {b} {# moves selected item to the default position in list XiVstActive
 global XV Wevst XiSelectedFromActive XiVstSelectedNr XiSelectedVstFile XiVstLastClick
 TestPut 2 ""
 if {$XiSelectedFromActive==""} {ConfigText $Wevst.e.t "$XV(anoentry)";  mybell 4; return}
 if {$XiSelectedFromActive==0}  {ConfigText $Wevst.e.t "$XV(anoact)";    mybell 4; return}
 if {$XiVstSelectedNr<=[lindex $XV(XSettVF$XiSelectedVstFile) 1]} \
				{ConfigText $Wevst.e.t "$XV(anomoveup)"; mybell 4; return}
 XiSettVHDel $XiVstSelectedNr;  set XiVstSelectedNr [lindex $XV(XSettVF$XiSelectedVstFile) 1]
 XiSettVHIns "" $XiVstSelectedNr "$XiVstLastClick";  XiSettVHFill;  XiSettVHSelItem "" $XiVstSelectedNr
 ConfigText $Wevst.e.t "[lindex $XV(XSettVBut$b) 3]"
}

proc XiTBKT {w} \
  {if {"$w"!=""} {ConfigText $w "editing of the displayed file (positioning: mouse, home, end, pg-up, pg-down, cursor)"}}

proc XiTextBindKeys {w wt wl} {# key bindings for editing in text widgets wt (mouse grab)/w=toplevel
 TestPut 2 "<$w><$wt><$wl>"
   # tkTextButton1 and tkTextSelectTo from /usr/local/lib/tk4.0/text.tcl (tk/tclversion dependent?)  
   bindtags $wt {T1 Text $w all}
   bind T1 <Home>            "$wt mark set insert 0.0; $wt yview -pickplace insert;        XiTBKT \"$wl\"; break"
   bind T1 <End>             "$wt mark set insert end; $wt yview -pickplace insert;        XiTBKT \"$wl\"; break"
   bind T1 <Button-1>        "tkTextButton1 %W %x %y;                                      XiTBKT \"$wl\"; break"
   bind T1 <B1-Motion>       "set tkPriv(x) %x; set tkPriv(y) %y; tkTextSelectTo %W %x %y; XiTBKT \"$wl\"; break"
   bind T1 <ButtonRelease-2> {catch {%W insert insert [selection get -selection PRIMARY]};                 break}
   bind T1 <Delete>          "selection clear $wt"
   bind T1 <BackSpace>       "selection clear $wt"
}

proc XiEVBEASBut {save} {
 global Wevst Wevstb XiWevstButList XiSelectedVstFile INSTPATH NEW XiCurLanguage XiVstHasSep
 TestPut 2 ""
 if {$save=="save"} {
   set file $INSTPATH/$NEW/locals_$XiCurLanguage/${XiSelectedVstFile}.tmp
   set f [open $file w]
   set lc [$Wevstb.b.t get "end -1c" end]
   if {($lc=="\n")} {puts -nonewline $f [$Wevstb.b.t get 1.0 "end-1c"]} \
   else             {puts -nonewline $f [$Wevstb.b.t get 1.0 end]}
   flush $f;  close $f
 }
 XiVst2Lists $XiSelectedVstFile tmp; XiSettVHFill; # XiSelectedVstFile.tmp --> XiVstActive/Inactive & fill windows
 unlink $INSTPATH/$NEW/locals_$XiCurLanguage/${XiSelectedVstFile}.tmp
 destroy $Wevstb;  raise $Wevst;  eval UnlockButtons $Wevst.a.ends $Wevst.a.save $Wevst.a.endq $XiWevstButList
 if {$XiVstHasSep==0} {$Wevst.d.frame2.5 configure -state disabled; bind $Wevst.d.frame2.5 <Button-1> ""}
}

proc XiEditVstEntryBabrt {} {TestPut 2 ""; XiEditVstEntryHexit}

proc XiEditVstEntryBends {} {TestPut 2 ""; if ![XiEditVstEntryHSave] return; XiEditVstEntryHexit}

proc XiEditVstEntryBnext {} {
 global XiVstSelectedNr XiSelectedFromActive  XiVstActive XiVstInactive
 TestPut 2 ""
 if {$XiSelectedFromActive==1} {set ll [llength $XiVstActive]} else {set ll [llength $XiVstInactive]}; incr ll -1
 if {($XiVstSelectedNr<0)||($XiVstSelectedNr>$ll)} {return}
 if ![XiEditVstEntryHSave] return
 if {$XiVstSelectedNr<$ll} {incr XiVstSelectedNr 1}; XiEditVstEntryHLoad $XiVstSelectedNr; XiEditVstEntryHPNLU
 if {$XiSelectedFromActive==1} {XiSettVHSelItem Active $XiVstSelectedNr} else {XiSettVHSelItem Inactive $XiVstSelectedNr}
}

proc XiEditVstEntryBprev {} {
 global XiVstSelectedNr XiSelectedFromActive XiVstActive XiVstInactive
 TestPut 2 ""
 if {$XiSelectedFromActive==1} {set ll [llength $XiVstActive]} else {set ll [llength $XiVstInactive]}; incr ll -1
 if {($XiVstSelectedNr<0)||($XiVstSelectedNr>$ll)} {return}
 if ![XiEditVstEntryHSave] return
 if {$XiVstSelectedNr>0} {incr XiVstSelectedNr -1}; XiEditVstEntryHLoad $XiVstSelectedNr; XiEditVstEntryHPNLU
 if {$XiSelectedFromActive==1} {XiSettVHSelItem Active $XiVstSelectedNr} else {XiSettVHSelItem Inactive $XiVstSelectedNr}
}

proc XiEditVstEntryHexit {} {
 global Wevst Wevstl XiWevstButList XiVstSelectedNr XiSelectedFromActive
 TestPut 2 ""
 eval UnlockButtons $Wevst.a.ends $Wevst.a.save $Wevst.a.endq $XiWevstButList;  raise $Wevst;  destroy $Wevstl
 if {$XiSelectedFromActive==1} {XiSettVHSelItem Active $XiVstSelectedNr} else {XiSettVHSelItem Inactive $XiVstSelectedNr}
}

proc XiEditVstEntryHPar {n} {
 global XV Wevstl XiVstPar XiSelectedVstFile XiVstLO
 TestPut 2 ""
 set wt [lindex $XV(XSettVF$XiSelectedVstFile) 4]; set wl [lindex $XV(XSettVF$XiSelectedVstFile) 5]
 set s [lindex $XV(XSettVF$XiSelectedVstFile) 6];  if {$s=="left"} {set a e} else {set a w}
 frame $Wevstl.b.$n;  pack $Wevstl.b.$n   -side top -anchor w -fill both -expand yes
 label $Wevstl.b.$n.l -width $wl -anchor $a; pack $Wevstl.b.$n.l -side $s  -anchor w
 if {[lindex [lindex $XV(XSettVF$XiSelectedVstFile) [expr $n+$XiVstLO]] 2]==""} {
   entry $Wevstl.b.$n.e -textvariable XiVstPar($n) -width $wt -relief sunken
                                             pack $Wevstl.b.$n.e -side $s  -anchor w -fill x    -expand yes
 } else {
   scrollbar $Wevstl.b.$n.s -command "$Wevstl.b.$n.e yview"
   text $Wevstl.b.$n.e -yscrollcommand "$Wevstl.b.$n.s set" \
	   -height [lindex [lindex $XV(XSettVF$XiSelectedVstFile) [expr $n+$XiVstLO]] 2]
   pack configure $Wevstl.b.$n.s -side right -fill y
   pack configure $Wevstl.b.$n.e -side right -fill both -expand yes
   XiTextBindKeys $Wevstl $Wevstl.b.$n.e ""
 }
}

proc XiEditVstEntryHLoad {nr} {# loads entry nr from list XiVstActive/Inactive acc.to XiSelectedFromActive
 global XV Wevstl XiVstActive XiVstInactive XiSelectedFromActive XiSelectedVstFile XiVstSep XiVstPar XiVstParAnz XiVstLO
 TestPut 2 ""
 if   {$XiSelectedFromActive==1} {set e [lindex "$XiVstActive"   $nr]} \
 else                            {set e [lindex "$XiVstInactive" $nr]}
 for {set n 0} {$n<=$XiVstParAnz} {incr n} {
   ConfigText $Wevstl.b.$n.l "[lindex [lindex $XV(XSettVF$XiSelectedVstFile) [expr $n+$XiVstLO]] 0] : "
   set XiVstPar($n) "[string trim [lindex [split $e $XiVstSep] $n]]"
   if {[lindex $XV(XSettVF$XiSelectedVstFile) [expr $n+$XiVstLO]]=="_"} \
	   {if [winfo exists $Wevstl.b.$n] {destroy $Wevstl.b.$n}}
   if {[lindex [lindex $XV(XSettVF$XiSelectedVstFile) [expr $n+$XiVstLO]] 2]!=""} {
     regsub -all "\},( )*" $XiVstPar($n) "\},\n" t
     $Wevstl.b.$n.e delete 0.0 end;  $Wevstl.b.$n.e insert end "$t";  $Wevstl.b.$n.e yview 0
   }
 }
 update
}

proc XiEditVstHSaveEmptyPar {parNr} {# empty parameter not allowd, give warning!
 global XV Wevst XiVstSelectedNr
 TestPut 2 ""
 set t "\t*** error: parameter $parNr in line [expr $XiVstSelectedNr+1] is empty!"
 XiProtokoll "\t$t";  ConfigText $Wevst.e.t "$t"
 mybell 4
}

proc XiEditVstEntryHSave {} {
 global XV Wevstl XiVstActive XiVstInactive XiSelectedFromActive XiSelectedVstFile XiVstSep XiVstHasSep XiVstLO
 global XiVstSelectedNr XiVstPar XiVstParAnz XiVstPBDL
 TestPut 2 ""
 set e ""
 for {set n 0} {$n<=$XiVstParAnz} {incr n} {
   if {$n>0} {set e "${e}$XiVstSep"}
   if {[lindex $XV(XSettVF$XiSelectedVstFile) [expr $n+$XiVstLO]]!="_"} {
     if {[lindex [lindex $XV(XSettVF$XiSelectedVstFile) [expr $n+$XiVstLO]] 2]==""} {set p "$XiVstPar($n)"} \
     else					{regsub -all "\n" [$Wevstl.b.$n.e get 1.0 end] " " p}
     if {$n==0} {
       for {set b [string length $p]} {$b<[lindex $XV(XSettVF$XiSelectedVstFile) 4]} {incr b} {set p "$p "}
       set e "${e}$p "
     } else {
       set e "${e} $p "
     }
   }
   if {($XiVstHasSep!="")&&([string first "$XiVstSep" $p]>=0)} \
	{ConfigText $Wevstl.c.t "Error: argument $n contains separator; please correct"; mybell 4; return 0}
   if {[string trim $p]==""} {
     set errempt 0
     if {([lindex [lindex $XV(XSettVF$XiSelectedVstFile) [expr $n+$XiVstLO]] 1]=="1")} {set errempt 1}
     if {[lindex $XV(XSettVF$XiSelectedVstFile) 1]=="1"} {# special analyse for file containing criteria line!
       if {$XiVstSelectedNr==0} {# criteria line
         if {![winfo exists $Wevstl.b.$n.e]} {set errempt 0}
         foreach i $XiVstPBDL {if {$i==$n} {set errempt 0}}
       } else {# other line
         if {$n>[lindex $XV(XSettVF$XiSelectedVstFile) 2]} {set errempt 1}
       }
     }
     if {$errempt} {XiEditVstHSaveEmptyPar [lindex [lindex $XV(XSettVF$XiSelectedVstFile) [expr $n+$XiVstLO]] 0]}
   }
 }
 if {$XiSelectedFromActive==1} {set XiVstActive   [lreplace $XiVstActive  $XiVstSelectedNr $XiVstSelectedNr "$e"]} \
 else                          {set XiVstInactive [lreplace XiVstInactive $XiVstSelectedNr $XiVstSelectedNr "$e"]}
 XiSettVHFill
 return 1
}

proc XiEditVstEntryHPNLU {} {# lock/unlock the previous/next buttons
 global Wevstl XiVstActive XiVstInactive XiVstSelectedNr XiSelectedFromActive XiVstPBDL XiVstPBDLw
 TestPut 2 ""
 if {$XiSelectedFromActive==1} {set anz [llength "$XiVstActive"]} else {set anz [llength "$XiVstInactive"]}; incr anz -1
 $Wevstl.a.prev configure -state normal; $Wevstl.a.next configure -state normal
 if {$XiVstSelectedNr==0}    {$Wevstl.a.prev configure -state disabled}
 if {$XiVstSelectedNr>=$anz} {$Wevstl.a.next configure -state disabled}
 if {($XiVstSelectedNr==0)} {
   set XiVstPBDLw "";  foreach n $XiVstPBDL \
	 {if [winfo exists $Wevstl.b.$n.e] {pack forget $Wevstl.b.$n.e; set XiVstPBDLw "$XiVstPBDLw $Wevstl.b.$n.e"}}
 }
 if {($XiVstSelectedNr==1)&&($XiVstPBDLw!="")} \
	 {foreach w $XiVstPBDLw {pack $w -anchor w -fill both -expand yes}; set XiVstPBDLw ""}
 update
}

#----- setting file edit menus        --------------------------------------------------------

proc XiSettEditNews {File} {# edit File (.news-file) in a text edit widget
 global XV Wvsts Wenews XiNewsfiles XiVstfiles INSTPATH NEW XiCurLanguage
 TestPut 3 "**********************<$File>"

 XiActivateFileEditButtons $Wvsts.b $XiNewsfiles .news 0; XiActivateFileEditButtons $Wvsts.c $XiVstfiles .vst 0
 $Wvsts.a.ende configure -state disabled; update idletasks
 
 XiProtokoll "$XV(AAsteriks)\nEdit News File \"$File.news\"\n"

 toplevel_init $Wenews "Edit News File" 400 100

 frame $Wenews.a -borderwidth 1 -relief raised; pack $Wenews.a -side top -fill x
 frame $Wenews.b -borderwidth 1 -relief raised; pack $Wenews.b -side top -pady 3 -fill both -expand yes
 frame $Wenews.c -borderwidth 1 -relief raised; pack $Wenews.c -side top -fill x

 # frame a: end and save buttons
 XiCreateESButtons $Wenews $File .news

 # frame b: file edit widget
 scrollbar $Wenews.b.s -command "$Wenews.b.t yview"
 text $Wenews.b.t -yscrollcommand "$Wenews.b.s set" -height 20 -width 80
 pack configure $Wenews.b.s -side right -fill y
 pack configure $Wenews.b.t -side right -fill both -expand yes
 XiTextBindKeys $Wenews $Wenews.b.t $Wenews.c.t
 set f [open $INSTPATH/$NEW/locals_$XiCurLanguage/$File.news r]
 $Wenews.b.t delete 0.0 end;  $Wenews.b.t insert end "[read $f]";  $Wenews.b.t yview 0
 close $f

 # frame c: Text
 label $Wenews.c.t -text "click first at edit field"; pack $Wenews.c.t -side top -anchor w
}

proc XiSettEditVst {File} {
 global XV Wevst Wvsts INSTPATH NEW XiNewsfiles XiVstfiles xtem_path language XiCurLanguage XiVstSelButtons XiVstParAnz
 global XiVstActive XiVstInactive XiSelectedFromActive XiSelectedVstFile XiVstSelectedNr XiWevstButList XiVstFL
 global XiVstHasSep XiVstSep XiVstParAnzMin XiMaxBoxWidth XiVstLO tclversion
 TestPut 3 "**********************<$File>"

 XiActivateFileEditButtons $Wvsts.b $XiNewsfiles .news 0; XiActivateFileEditButtons $Wvsts.c $XiVstfiles .vst 0
 $Wvsts.a.ende configure -state disabled; update

 XiProtokoll "$XV(AAsteriks)\nEdit Setting File \"...$XiCurLanguage/$File.vst\"\n"

 if [info exists XV(XSettVF$File.vst)] {TestPut 2 "P1: <$XV(XSettVF$File.vst)>"}
 set xtem_path "$INSTPATH/$NEW"; set language "$XiCurLanguage"; XiVst2Lists $File.vst ""; # File --> XiVstActive/Inactive
 if {([lindex $XV(XSettVF$File.vst) 3]==1)&&($XiVstParAnz>[lindex $XV(XSettVF$File.vst) 2])} {# update XV(XSettVFxxx.vst)
   set XiVstParAnzMin [lindex $XV(XSettVF$File.vst) 2]
   TestPut 1 "    <[expr [lindex $XV(XSettVF$File.vst) 2]+1]>...<$XiVstParAnz>"
   for {set n [expr [lindex $XV(XSettVF$File.vst) 2]+1]} {$n<=$XiVstParAnz} {incr n} {
    TestPut 1 "    <[llength $XV(XSettVF$File.vst)]><[expr $n+$XiVstLO]>"
    if {[llength $XV(XSettVF$File.vst)]<=[expr $n+$XiVstLO]} {
     lappend XV(XSettVF$File.vst) [string trim [lindex [split $XiVstFL $XiVstSep] $n]]
    } else {
     set p [expr $n+$XiVstLO]; set e [llength $XV(XSettVF$File.vst)]
     set XV(XSettVF$File.vst) [lreplace $XV(XSettVF$File.vst) $p $e [string trim [lindex [split $XiVstFL $XiVstSep] $n]]]
    }
   }
   set XV(XSettVF$File.vst) [lreplace $XV(XSettVF$File.vst) 7 7 $XiVstParAnz]
 }
 if [info exists XV(XSettVF$File.vst)] {TestPut 2 "P2: <$XV(XSettVF$File.vst)>"}

 if ![info exists XV(XSettVCom$XiCurLanguage)] {set XV(XSettVCom$XiCurLanguage) "$XV(XSettVComenglish)"}
 set XiSelectedFromActive "";  set XiSelectedVstFile "$File.vst";  set XiVstSelectedNr ""

 set t "Edit Setting File: ...$XiCurLanguage/$File.vst"
 if $XiVstHasSep {set t "$t (Separator=\"$XiVstSep\")"} else {set t "$t (Has no Separator)"}
 toplevel_init $Wevst "$t" 400 100

 frame $Wevst.a -borderwidth 1 -relief raised;  pack $Wevst.a -side top -fill x
 frame $Wevst.b -borderwidth 1 -relief raised;  pack $Wevst.b -side top -fill x
 frame $Wevst.c -borderwidth 1 -relief raised;  pack $Wevst.c -side top -fill x
 frame $Wevst.d -borderwidth 1 -relief raised;  pack $Wevst.d -side top -fill x
 frame $Wevst.e -borderwidth 1 -relief raised;  pack $Wevst.e -side top -fill x

 # frame a: end and save buttons
 XiCreateESButtons $Wevst $File .vst

 # frame b: setting file line selection menu: active entries
 XiCreateLSBox $Wevst.b "active entries:" top $XiMaxBoxWidth 10 2 $XiVstActive   XiSettVHSelLineActive

 # frame c: setting file line selection menu: inactive entries
 XiCreateLSBox $Wevst.c "inactive entries (=comment):" top $XiMaxBoxWidth  5 2 $XiVstInactive XiSettVHSelLineInactive

 # frame d: buttons
 set line 1; set Buttons "$XV(XSettVButtons)"; set XiWevstButList ""
 if {[lindex $XV(XSettVF$XiSelectedVstFile) 3]==1} {set Buttons "$Buttons 13 14"}
 while {$Buttons!=""} {
   frame $Wevst.d.frame$line; pack $Wevst.d.frame$line -side top -anchor nw
   for {set n 1} {$n<=4} {incr n} {
     set bnr [lindex $Buttons 0]; set Buttons [lrange $Buttons 1 end]
     button $Wevst.d.frame$line.$bnr  -width 16 -text "[lindex $XV(XSettVBut$bnr) 0]" -anchor w
     set XiWevstButList "$XiWevstButList $Wevst.d.frame$line.$bnr"
     pack $Wevst.d.frame$line.$bnr -side left
     bind $Wevst.d.frame$line.$bnr <Button-1> "[lindex $XV(XSettVBut$bnr) 1] $bnr"
     bind $Wevst.d.frame$line.$bnr <Enter> "ConfigText $Wevst.e.t \"[lindex $XV(XSettVBut$bnr) 2]\""
     bind $Wevst.d.frame$line.$bnr <Leave> {ConfigText $Wevst.e.t ""}
     if {$Buttons==""} {break}
   }
   incr line
 }
 set l "$Wevst.d.frame1.2 $Wevst.d.frame2.5 $Wevst.d.frame3.9 $Wevst.d.frame3.10"
 if {$XiVstHasSep==0} {foreach b $l {$b configure -state disabled; bind $b <Button-1> ""}}

 # frame e: Text
 label $Wevst.e.t -text ""; pack $Wevst.e.t -side top -anchor w
 if {"$File"=="mkcommand"} {
   global MkcmdTclVColNr; if [info exists MkcmdTclVColNr] {unset MkcmdTclVColNr}; set mkcmdcol [MkcmdTclVCol no-exit]
   if {$mkcmdcol==0} {ConfigText $Wevst.e.t "$XV(MkCmdNCol1) $tclversion; $XV(MkCmdNCol2)"; mybell 4}
 }
}

proc XiSettVBEditBuff  {b} {# edit file XiSelectedVstFile (all entries) in a text edit widget
 global XV Wevst Wevstb XiSelectedVstFile XiWevstButList INSTPATH NEW XiCurLanguage XiVstHasSep XiVstSep
 TestPut 3 "**********************<$b>"

 XiSettVHSelClear
 eval LockButtons $Wevst.a.ends $Wevst.a.save $Wevst.a.endq $XiWevstButList
 XiSaveVstfile  ${XiSelectedVstFile}.tmp 0

 if $XiVstHasSep {toplevel_init $Wevstb "Edit Buffer: \"$XiSelectedVstFile\" (Separator=\"$XiVstSep\")" 400 100} \
 else            {toplevel_init $Wevstb "Edit Buffer: \"$XiSelectedVstFile\" (Has no Separator)" 400 100}

 frame $Wevstb.a -borderwidth 1 -relief raised; pack $Wevstb.a -side top -fill x
 frame $Wevstb.b -borderwidth 1 -relief raised; pack $Wevstb.b -side top -pady 3 -fill both -expand yes
 frame $Wevstb.c -borderwidth 1 -relief raised; pack $Wevstb.c -side top -fill x

 # frame a: end and save buttons
 button $Wevstb.a.end -text "end";  pack $Wevstb.a.end -side left
 button $Wevstb.a.ext -text "abort"; pack $Wevstb.a.ext -side left
 bind $Wevstb.a.end <Button-1> "XiEVBEASBut   save; Bend"
 bind $Wevstb.a.ext <Button-1> "XiEVBEASBut nosave; Bend"
 bind $Wevstb.a.end <Enter> {ConfigText $Wevstb.c.t "end edit buffer window, using current contents of this window"}
 bind $Wevstb.a.ext <Enter> {ConfigText $Wevstb.c.t "exit edit buffer window, ignore all changes done in this window"}
 bind $Wevstb.a.end <Leave> {ConfigText $Wevstb.c.t ""}
 bind $Wevstb.a.ext <Leave> {ConfigText $Wevstb.c.t ""}
 
 # frame b: file edit widget
 scrollbar $Wevstb.b.s -command "$Wevstb.b.t yview"
 text $Wevstb.b.t -yscrollcommand "$Wevstb.b.s set" -height 20 -width 80
 pack configure $Wevstb.b.s -side right -fill y
 pack configure $Wevstb.b.t -side right -fill both -expand yes
 XiTextBindKeys $Wevstb $Wevstb.b.t $Wevstb.c.t
 set f [open $INSTPATH/$NEW/locals_$XiCurLanguage/${XiSelectedVstFile}.tmp r]
 $Wevstb.b.t delete 0.0 end;  $Wevstb.b.t insert end "[read $f]";  $Wevstb.b.t yview 0
 close $f

 # frame c: Text
 label $Wevstb.c.t -text "click first at edit field"; pack $Wevstb.c.t -side top -anchor w
}

proc XiSettVHEditEntry {nr} {# edit item $nr from the active lists XiVstActive/Inactive acc.to XiSelectedFromActive
 global XV Wevst Wevstl XiSelectedFromActive XiWevstButList XiSelectedVstFile XiVstHasSep XiVstSep XiVstParAnz
 global XiVstPBDL XiVstPBDLw
 TestPut 3 "**********************<$nr>"

 if {$XiSelectedFromActive==""} {ConfigText $Wevst.e.t "$XV(anoentry)";  mybell 4; return}
 if {$XiSelectedFromActive==0}  {ConfigText $Wevst.e.t "$XV(anoact)";    mybell 4; return}

 eval LockButtons $Wevst.a.ends $Wevst.a.save $Wevst.a.endq $XiWevstButList

 set t "Edit an Entry in Setting File:"
 if $XiVstHasSep {toplevel_init $Wevstl "$t \"$XiSelectedVstFile\" (Separator=\"$XiVstSep\")" 600 150} \
 else            {toplevel_init $Wevstl "$t \"$XiSelectedVstFile\" (Has no Separator)" 600 150}

 frame $Wevstl.a -borderwidth 1 -relief raised; pack $Wevstl.a -side top -fill x -expand yes
 frame $Wevstl.b -borderwidth 1 -relief raised; pack $Wevstl.b -side top -pady 3 -fill both -expand yes
 frame $Wevstl.c -borderwidth 1 -relief raised; pack $Wevstl.c -side top -fill x -expand yes

 # frame a: end, previous, next, abort, delete_parameter and add_parameter buttons
 set butlist "ends prev next abrt";# if {[lindex $XV(XSettVF$XiSelectedVstFile) 3]==1} {set butlist "$butlist pdel padd"}
 foreach b $butlist {
   button $Wevstl.a.$b -text $XV(Xeeb$b)
   if {($b=="pdel")||($b=="padd")} {pack $Wevstl.a.$b -side right} else {pack $Wevstl.a.$b -side left}
   bind $Wevstl.a.$b <Button-1> "XiEditVstEntryB$b; Bend"
   bind $Wevstl.a.$b <Enter> "ConfigText $Wevstl.c.t \"$XV(Xeet$b)\""
   bind $Wevstl.a.$b <Leave> "ConfigText $Wevstl.c.t \"\""
 }

 # frame b: item edit widget
 for {set n 0} {$n<=$XiVstParAnz} {incr n} {XiEditVstEntryHPar $n}
 set XiVstPBDLw ""; set XiVstPBDL ""; if {$XiSelectedVstFile=="printing.vst"} {set XiVstPBDL "0 4 5 6 7"}
 XiEditVstEntryHLoad $nr;  XiEditVstEntryHPNLU

 # frame c: Text
 label $Wevstl.c.t -text ""; pack $Wevstl.c.t -side top -anchor w
}

proc XiSettVBParDel {b} {# delete a paramter (to be specified in a window now generated) from each entry
 global XV Wevst Wevstd XiWevstButList XiSelectedVstFile XiVstSep
 TestPut 3 "**********************<$b>"

 XiSettVHSelClear;  ConfigText $Wevst.e.t "[lindex $XV(XSettVBut$b) 3]"

 eval LockButtons $Wevst.a.ends $Wevst.a.save $Wevst.a.endq $XiWevstButList

 toplevel_init $Wevstd "Deleting a Parameter in File: \"$XiSelectedVstFile\" (Separator=\"$XiVstSep\")" 500 100

 frame $Wevstd.a -borderwidth 1 -relief raised; pack $Wevstd.a -side top -fill x
 frame $Wevstd.b -borderwidth 1 -relief raised; pack $Wevstd.b -side top -pady 3 -fill both -expand yes
 frame $Wevstd.c -borderwidth 1 -relief raised; pack $Wevstd.c -side top -fill x

 # frame a: end button
 button $Wevstd.a.e -text "end"; pack $Wevstd.a.e -side left
 bind $Wevstd.a.e <Button-1> \
      "eval UnlockButtons $Wevst.a.ends $Wevst.a.save $Wevst.a.endq $XiWevstButList; raise $Wevst; destroy $Wevstd; Bend"
 bind $Wevstd.a.e <Enter> "ConfigText $Wevstd.c.t \"ends this window\""
 bind $Wevstd.a.e <Leave> "ConfigText $Wevstd.c.t \"\""

 # frame b: select&delete parameter widget
 XiCreateLSBox $Wevstd.b "Clicking at parameter in this list will delete it form all entries!:" top 40 10 2 \
	[XiSettVHParList] XiSettVHParDel

 # frame c: Text
 label $Wevstd.c.t -text ""; pack $Wevstd.c.t -side top -anchor w
}

proc XiSettVBParAdd {b} {# add a paramter (to be specified in a window now generated) top each entry
 global XV Wevst Wevsta XiWevstButList XiSelectedVstFile XiVstSep XiVstParNew
 TestPut 3 "**********************<$b>"

 XiSettVHSelClear;  ConfigText $Wevst.e.t "[lindex $XV(XSettVBut$b) 3]"

 eval LockButtons $Wevst.a.ends $Wevst.a.save $Wevst.a.endq $XiWevstButList

 toplevel_init $Wevsta "Adding a Parameter in File: \"$XiSelectedVstFile\" (Separator=\"$XiVstSep\")" 500 100

 frame $Wevsta.a -borderwidth 1 -relief raised; pack $Wevsta.a -side top -fill x
 frame $Wevsta.b -borderwidth 1 -relief raised; pack $Wevsta.b -side top -pady 3 -fill both -expand yes
 frame $Wevsta.c -borderwidth 1 -relief raised; pack $Wevsta.c -side top -fill x

 # frame a: end button
 button $Wevsta.a.e -text "end"; pack $Wevsta.a.e -side left
 button $Wevsta.a.c -text "create parameter"; pack $Wevsta.a.c -side left
 bind $Wevsta.a.e <Button-1> \
      "eval UnlockButtons $Wevst.a.ends $Wevst.a.save $Wevst.a.endq $XiWevstButList; raise $Wevst; destroy $Wevsta; Bend"
 bind $Wevsta.a.e <Enter> "ConfigText $Wevsta.c.t \"ends this window\""
 bind $Wevsta.a.e <Leave> "ConfigText $Wevsta.c.t {}"
 bind $Wevsta.a.c <Button-1> "XiSettVHParAdd"
 bind $Wevsta.a.c <Enter> "ConfigText $Wevsta.c.t {creates (appending) a new parameter}"
 bind $Wevsta.a.c <Leave> "ConfigText $Wevsta.c.t {}"

 # frame b: select&delete parameter widget
 label $Wevsta.b.l -text "left mouse click, then enter the name of parameter to be created:"; pack $Wevsta.b.l -anchor w
 entry $Wevsta.b.p -textvariable XiVstParNew -width 30 -relief sunken; pack $Wevsta.b.p -anchor w -fill x -expand yes
 set XiVstParNew ""

 # frame c: Text
 label $Wevsta.c.t -text ""; pack $Wevsta.c.t -side top -anchor w
}

proc XiSettVHParDel {} {# deletes a user definable parameter (e.g. in printing.vst)
 global XV Wevstd XiSelectedVstFile XiVstSep XiVstParAnzMin XiVstParAktEL XiVstParAnz XiVstLastClick XiVstLO
 global XiVstFL XiVstActive XiVstInactive
 TestPut 2 ""
 if {($XiVstLastClick=="")||([lindex $XV(XSettVF$XiSelectedVstFile) 7]<=$XiVstParAnzMin)} {return ""}
 incr XiVstParAnz -1;  set XV(XSettVF$XiSelectedVstFile) [lreplace $XV(XSettVF$XiSelectedVstFile) 7 7 $XiVstParAnz]
 set pardel [lindex $XiVstLastClick 1]
 set n [expr $pardel+$XiVstLO]; set XV(XSettVF$XiSelectedVstFile) \
     [lreplace $XV(XSettVF$XiSelectedVstFile) [expr $n-1] $n [lindex $XV(XSettVF$XiSelectedVstFile) [expr $n-1]]]
 set fl [split $XiVstFL $XiVstSep];  set XiVstFL "[lindex $fl 0]"
 set fl [lreplace $fl [expr $pardel-1] $pardel [lindex $fl [expr $pardel-1]]]
 for {set n 1} {$n<=$XiVstParAnz} {incr n} {set XiVstFL "${XiVstFL}${XiVstSep}[lindex $fl $n]"}
 $Wevstd.b.f.f.li delete 0 end; foreach e [XiSettVHParList] {$Wevstd.b.f.f.li insert end $e}
 set XiVstActive   [XiSettVHParDelN $pardel $XiVstActive]
 set XiVstInactive [XiSettVHParDelN $pardel $XiVstInactive]
 XiSettVHFill
}

proc XiSettVHParAdd {} {
 global XV Wevsta XiVstFL XiVstParNew XiVstActive XiVstInactive XiSelectedVstFile XiVstSep XiVstParAnz XiVstLO
 TestPut 2 ""
 set XiVstParNew [string trim $XiVstParNew]
 if {$XiVstParNew==""} \
	{ConfigText $Wevsta.c.t "missing parameter name --- enter into the entry window!"; mybell 4; return}
 incr XiVstParAnz 1;  set XV(XSettVF$XiSelectedVstFile) [lreplace $XV(XSettVF$XiSelectedVstFile) 7 7 $XiVstParAnz]
 if {[string first " " $XiVstParNew]>=0} \
	{ConfigText $Wevsta.c.t "parameter name cannot contain blanks!"; mybell 4; return}
 set XV(XSettVF$XiSelectedVstFile) [linsert $XV(XSettVF$XiSelectedVstFile) [expr $XiVstParAnz+$XiVstLO] $XiVstParNew]
 set fl [split $XiVstFL $XiVstSep];  set XiVstFL "[lindex $fl 0]"
 for {set n 1} {$n<$XiVstParAnz} {incr n} {set XiVstFL "${XiVstFL}${XiVstSep}[lindex $fl $n]"}
 set XiVstFL "${XiVstFL}${XiVstSep} $XiVstParNew "
 set XiVstActive   [XiSettVHParAddL Active   $XiVstActive]
 set XiVstInactive [XiSettVHParAddL Inactive $XiVstInactive]
 set XiVstParNew ""
 XiSettVHFill
}

#---------------------------------------------------------------------------------------------
proc XiEditVstEntryBpadd {} {TestPut 2 ""; puts "***** XiEditVstEntryBpadd not implemented --- see XiSettVBParAdd"}
proc XiEditVstEntryBpdel {} {TestPut 2 ""; puts "***** XiEditVstEntryBpdel not implemented --- see XiSettVBParDel"}
